#include "httpd.h"

/* PostgreSQL access functions */
#include "libpq-fe.h"
#include <stdlib.h>
#include <unistd.h>

#include "../include/co_convutils.h"

int
cou_createJSFromRs
(
    PGresult *res,
    char *strOut,
    char *callback
)
{
    int i,j;
    int nFields;
    char valBuf[FIELDBUFSIZE];

    memset(valBuf,0,FIELDBUFSIZE);

    nFields = PQnfields(res);
    strOut[0]=0;

    sprintf(strOut+strlen(strOut), "var o = new Object();\n");
    sprintf(strOut+strlen(strOut), "o.d = new Object();\n");

    for (i = 0; i < nFields; i++)
    {
        if(strlen(strOut)+100>JSBUFSIZE) return(-1);
	sprintf(strOut+strlen(strOut), "o.d.%s = new Array();\n",PQfname(res, i));
    }

    for (i = 0; i < PQntuples(res); i++)
    {
        for (j = 0; j < nFields; j++)
	{
	    if(strlen(strOut)+100>JSBUFSIZE) return(-1);
	    cou_JSEncode( (char *) PQgetvalue(res, i, j), valBuf);
	    sprintf(strOut+strlen(strOut), "o.d.%s[%d] = \"%s\";\n",PQfname(res, j),
        				i, valBuf);
	}
    }

    sprintf(strOut+strlen(strOut), "%so);\n",callback);
    return(0);

};


int
cou_createJSFromRsWithClassName
(
    PGresult *res,
    char *className,
    char *strOut
)
{
    int i,j;
    int nFields;
    char valBuf[FIELDBUFSIZE];

    memset(valBuf,0,FIELDBUFSIZE);

    nFields = PQnfields(res);
    strOut[0]=0;
    sprintf(strOut, "var o=new Object();\n");
    sprintf(strOut, "var o.class='%s';\n",className);
    sprintf(strOut, "var o.d=new Object();\n");
    for (i = 0; i < nFields; i++)
    {
        if(strlen(strOut)+100>JSBUFSIZE) return(-1);
	sprintf(strOut+strlen(strOut), "o.d.%s=new Array();\n",PQfname(res, i));
    }

    for (i = 0; i < PQntuples(res); i++)
    {
        for (j = 0; j < nFields; j++)
	{
	    if(strlen(strOut)+100>JSBUFSIZE) return(-1);
	    cou_JSEncode( (char *) PQgetvalue(res, i, j), valBuf);
	    sprintf(strOut+strlen(strOut), "o.d.%s[%d]='%s';\n",PQfname(res, j),
        				i, valBuf);
	}
    }
    return(0);
}

/*this function changes all occurences of " to \" * and ' to \' */
int
cou_JSEncode
(
    char *strIn,
    char *strOut
)
{
    int i,j;

    memset(strOut,0,2*strlen(strIn));
    //strOut[0]=0;
    for(i=0,j=0; i<=strlen(strIn); i++,j++)
    {
      /* 34 is " , 39 is ' */
       if(strIn[i]==34 || strIn[i]==39)
       {
         strOut[j]=92; /* 92 = 34 + 34 + 34 + 34 - 39 + 34 - 39; */
         j++;
       }
       strOut[j]=strIn[i];
    }
    return(0);
}

/*this function changes all occurences of ' to '' */
int
cou_SQLEncode
(
    char *strIn,
    char *strOut
)
{
    int i,j;

    strOut[0]=0;
    for(i=0,j=0; i<=strlen(strIn); i++,j++)
    {
      /* 39 is '  */
       if(strIn[i]==39)
       {
         strOut[j]=39;
         j++;
         strOut[j]=39;
       }
       else
       {
         strOut[j]=strIn[i];
       }
    }
    return(0);
}

/*this function changes all occurences of ' to '' and " to \\" */
int
cou_SQLArrayEncode
(
    char *strIn,
    char *strOut
)
{
    int i,j;

    strOut[0]=0;
    for(i=0,j=0; i<=strlen(strIn); i++,j++)
    {
      /* 39 is '  */
       if(strIn[i]==39) strOut[j++]=39;
      /* 34 is " */
       if(strIn[i]==34) { strOut[j++]=92; strOut[j++]=92; }
       
       strOut[j]=strIn[i];
    }
    return(0);
}

/*this function splits string into substrings */
int
cou_split
(
    char *strIn,
    char **strTabOut,
    const char *delim,
    int intTabOutLenMax
)
{
    int i=0;
    strTabOut[0]=strIn;
    i++;
    while( (strTabOut[i] = strstr(strTabOut[i-1],delim)) )
    {
       strTabOut[i][0]=0;
       strTabOut[i] += strlen(delim);
       i++;
       if(i>=intTabOutLenMax) return -1;
    };

    return i;
}


