/*
 * Copyright (C) by LeftHand sp. z o.o.
 * See http://www.corporateoffice.pl
 */

#include "httpd.h"
#include "http_config.h"
#include "http_main.h"
#include "http_protocol.h"

#include "co_context.h"
#include "co_output.h"

void
cou_putsHTML( co_context *ctx, const char* str)
{
    request_rec *r;

    r = ctx->request;
    /* check if HTML is expected; prepare client for HTML */
    switch (ctx->html_mode) {
        case CO_NO_HTML: return; break;
        case CO_OUTSIDE:
            r->content_type = "text/html";
            ap_send_http_header(r);
            ap_rputs(DOCTYPE_HTML_4_0T, r);
            ap_rputs("<HTML>\n", r);
            ctx->html_mode = CO_HTML;
            break;
        case CO_HTML   :
        case CO_HEAD   :
        case CO_BODY   : break;
        case CO_SCRIPT : return; break;
    }
    ap_rputs( str, r );
}

void
cou_finishHTML( co_context *ctx )
{
    request_rec *r;

    r = ctx->request;
    /* check if HTML is expected; prepare client for HTML */
    switch (ctx->html_mode) {
    case CO_NO_HTML:
    case CO_OUTSIDE:
        return;
        break;
    case CO_SCRIPT : ap_rputs("</SCRIPT>\n", r);
    case CO_HEAD   : ap_rputs("</HEAD>\n<BODY>\n", r);
    case CO_BODY   : ap_rputs("</BODY>\n", r);
    case CO_HTML   : ap_rputs("</HTML>\n", r);
        ctx->html_mode = CO_OUTSIDE;
        break;
    }
}
