#include "httpd.h"
#include "http_config.h"
#include "http_protocol.h"
#include "http_log.h"
#include "ap_config.h"

/* PostgreSQL access functions */
#include "libpq-fe.h"

//#include "co_utils.h"
//#include "co_log.h"
#include "co_lib.h"
#include "co_defines.h"
#include "co_defines_calls.h"
#include "co_mod.h"
#include "../comodules/generic_acl/co_generic_acl.h"
#include "../comodules/catalog/co_catalog.h"
#include "../comodules/text_document/co_text_document.h"

#include "co_recordset.h"
#include "co_string.h"
#include "co_public_web.h"
#include "mod_coffice.h"
#include "co_broker.h"


int co_public_web_map(co_context * cnx)
{
	request_rec *r = cnx->request;
    pool *p = cnx->request->pool;
	int id_object = 0;
	int err = 0;
	char MESGString[MESGSIZE]; 
	co_recordset * corec;
	char * obj_type;
	int is_asp = 0;

	//TYMCZASOWE!!!!!!!!!!!!
	cnx->check_security = 0;

//	ap_rputs(r->path_info, r);

	// if path is ended with '/' then we add start.asp
	if(r->path_info[strlen(r->path_info)-1] == '/')
	{
		r->path_info = ap_pstrcat(p, r->path_info, "start.asp", NULL);
	}

	//getting id of object 
	{
    	__PARAM_STRUCT_CREATE_getIdByPath(out_param1)
		__PARAM_STRUCT_SET("sys", out_param1, par_area)
		__PARAM_STRUCT_SET("catalog", out_param1, par_class)
		__PARAM_STRUCT_SET(2, out_param1, par_id)
		__PARAM_STRUCT_SET(2, out_param1, id_root)
		__PARAM_STRUCT_SET(r->path_info, out_param1, path)
		cou_broker("sys", "catalog", "getIdByPath", cnx, out_param1);
		__GET_RETURNED_INTEGER(id_object)
	}
	if(id_object == -1)
	{
		ap_rprintf(r, "OBIEKT: %s NIE ISTNIEJE", r->path_info);
		return OK;
	}

	{
    	__PARAM_STRUCT_CREATE_getItemData(out_param1)
		__PARAM_STRUCT_SET("sys", out_param1, par_area)
		__PARAM_STRUCT_SET("catalog", out_param1, par_class)
		__PARAM_STRUCT_SET(id_object, out_param1, par_id)
		cou_broker("sys", "catalog", "getItemData", cnx, out_param1);
		__GET_RETURNED_RECORDSET(corec)
	}

	if(cor_GetTupleCount(cnx, corec) != 1)
	{
		ap_rprintf(r, "OBIEKT: %s NIE ISTNIEJE W SYSTEMIE", r->path_info);
		return OK;
	}

	obj_type = cor_GetValueByName(cnx, corec, 0, "type_class_name");
//	ap_rprintf(r, "typ: %s", obj_type);

	// if this is catalog we look for 'start.asp'
	// BUT: it really shoud not be since we add 'start.asp' for paths ending with "/" !
	if(strcmp(obj_type, "catalog") == 0)
	{

    	__PARAM_STRUCT_CREATE_getIdByPath(out_param1)
		__PARAM_STRUCT_SET("sys", out_param1, par_area)
		__PARAM_STRUCT_SET("catalog", out_param1, par_class)
		__PARAM_STRUCT_SET(id_object, out_param1, par_id)
		__PARAM_STRUCT_SET(id_object, out_param1, id_root)
		__PARAM_STRUCT_SET("start.asp", out_param1, path)
		cou_broker("sys", "catalog", "getIdByPath", cnx, out_param1);
		__GET_RETURNED_INTEGER(id_object)
	
		if(id_object == -1)
		{
			ap_rprintf(r, "OBIEKT: %s NIE ISTNIEJE", r->path_info);
			return OK;
		}

		//we get data again
		{
    		__PARAM_STRUCT_CREATE_getItemData(out_param1)
			__PARAM_STRUCT_SET("sys", out_param1, par_area)
			__PARAM_STRUCT_SET("catalog", out_param1, par_class)
			__PARAM_STRUCT_SET(id_object, out_param1, par_id)
			cou_broker("sys", "catalog", "getItemData", cnx, out_param1);
			__GET_RETURNED_RECORDSET(corec)
		}

		if(cor_GetTupleCount(cnx, corec) != 1)
		{
			ap_rprintf(r, "OBIEKT: %s NIE ISTNIEJE W SYSTEMIE", r->path_info);
			return OK;
		}
		obj_type = cor_GetValueByName(cnx, corec, 0, "type_class_name");
	}


	if(strlen(r->path_info)>4) 
	if(strcmp(r->path_info + strlen(r->path_info) - 4, ".asp") == 0) is_asp = 1;

	//executing as ASP 
	if(strcmp(obj_type, "text_document") == 0 && is_asp)
	{
		int id = atoi(cor_GetValueByName(cnx, corec, 0, "id_item"));

    	__PARAM_STRUCT_CREATE_evalTextDocumentAsASP(out_param1)
		__PARAM_STRUCT_SET("sys", out_param1, par_area)
		__PARAM_STRUCT_SET("text_document", out_param1, par_class)
		__PARAM_STRUCT_SET(id, out_param1, par_id)
		cou_broker("sys", "text_document", "evalTextDocumentAsASP", cnx, out_param1);
	}

	//sending file
	if(strcmp(obj_type, "text_document") == 0 && !is_asp)
	{
		int id = atoi(cor_GetValueByName(cnx, corec, 0, "id_item"));

    	__PARAM_STRUCT_CREATE_evalTextDocumentAsASP(out_param1)
		__PARAM_STRUCT_SET("sys", out_param1, par_area)
		__PARAM_STRUCT_SET("text_document", out_param1, par_class)
		__PARAM_STRUCT_SET(id, out_param1, par_id)
		cou_broker("sys", "text_document", "getFile", cnx, out_param1);
	}


	if(strcmp(obj_type, "attachment") == 0)
	{
		int id = atoi(cor_GetValueByName(cnx, corec, 0, "id_item"));

    	__PARAM_STRUCT_CREATE_evalTextDocumentAsASP(out_param1)
		__PARAM_STRUCT_SET("sys", out_param1, par_area)
		__PARAM_STRUCT_SET("attachment", out_param1, par_class)
		__PARAM_STRUCT_SET(id, out_param1, par_id)
		cou_broker("sys", "attachment", "getFile", cnx, out_param1);
	}

	cnx->check_security = 1;
	return OK;
}


