
#include "../../include/types.t"

#define __PARAMS_HEADER2 \
    param par_area {type CO_STRING;}; \
    param par_class {type CO_STRING;};\
    param par_id { type CO_INTEGER; }; \
    
class acl
{
   
   area sec;

#include "../../include/check_acl.t"
   
   inherits generic;
   
   container_class '';
   container_column_name '';

#include "../../include/generic_props.t"

  index in1 
  { 
    unique 0; 
    column id_permission; 
    column id_role; 
    column id_object; 
    column class_name; 
    column area; 
  }; 

  index in2 
  { 
    unique 0; 
    column id_role; 
    column id_object; 
    column class_name; 
    column area; 
  }; 

  index in3
  { 
    unique 0; 
    column id_object; 
    column class_name; 
    column area; 
  }; 

   prop id_permission
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 1;
     foreign 'permission';
     foreign_prop 'id';
     position 200;
   };
   
   prop id_object
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 1;
     foreign 'DYNAMIC=class_name';
     foreign_prop 'id';
     position 200;

   };
   
   prop id_role
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 1;
     foreign 'role';
     foreign_prop 'id';
     position 200;

   };

   prop area
   {
     type CO_STRING;
     default "''";
     params '';
     representant 1;
     foreign '';
     foreign_prop '';
     position 200;
   };

   prop class_name
   {
     type CO_STRING;
     default "''";
     params '';
     representant 1;
     foreign 'meta_class';
     foreign_prop 'id';
     position 200;
   };
                  
	function_sql check
	{
		doc "check acl for given area, class_name, id_object, id_permission and id_role";
		params '(text, text, int, int, int)';
		returns int;
		language sql;

		S
		%%
		SELECT 1 FROM co_sec_acl
			WHERE area = $1 AND class_name = $2 AND id_object = $3 AND id_permission = $4 AND id_role = $5 ;   
		%%
		;
	};  

}; // class
