#include "../../include/init_file_names.t"
#include "../../include/defines.t"      

file __INIT_CATALOG()
{

class catalog
{
  area sys;
  full_control root;
  full_control user;
  remove_old "name='root'";
  p name {val root;};

	/* This is VERY important that first type in catalog is 'catalog' */
	p id_catalog_type {val 1;};

	/* user with id=1 is system */
	p id_user {val 1;};
	p id {val 1;};
	
};

class catalog
{
  area sys;
  full_control root;
  full_control user;
  full_control __PUBLIC__;
  
  remove_old "name='public_web'";
  p name {val public_web;};

	/* This is VERY important that first type in catalog is 'catalog' */
	p id_catalog_type {val 1;};

	/* user with id=1 is system */
	p id_user {val 1;};
	p id {val 2;};
	p id_parent {val 1;};
	
};

}; // end file catalog


file __INIT_MENU_CATALOG()
{

/* this is default menu that we can see on generic forms */
class menu
{
  area sys;
  full_control root;
  full_control user;

  remove_old "name='default_catalog'";
  p name       {val		default_catalog;};
  p id_parent  {getByName 	menu {f root;};};
  p class_name {val		catalog;};
};

/*this is menu for left side on catalog form */
class menu
{
  area sys;
  full_control root;
  full_control user;

  remove_old "name='l_catalog_catalog'";

  p name       {val		l_catalog_catalog;};
  p id_parent  {getByName 	menu {f root;};};
  p class_name {val		catalog;};
};

/* this is menu for right side on catalog form */
class menu
{
  area sys;
  full_control root;
  full_control user;

  remove_old "name='r_catalog_catalog'";

  p name       {val		r_catalog_catalog;};
  p id_parent  {getByName 	menu {f root;};};
  p class_name {val		catalog;};
};

/*this is menu for left side on catalog form for role*/
class menu
{
  area sec;
  full_control root;
  full_control user;

  remove_old "name='l_catalog_role'";

  p name       {val		l_catalog_role;};
  p id_parent  {getByName 	menu {f root;};};
  p class_name {val		catalog;};
};

/* this is menu for right side on catalog form for role*/
class menu
{
  area sec;
  full_control root;
  full_control user;

  remove_old "name='r_catalog_role'";

  p name       {val		r_catalog_role;};
  p id_parent  {getByName 	menu {f root;};};
  p class_name {val		catalog;};
};

/* this is menu for right side on catalog form for role*/
class menu
{
  area usr;
  full_control root;
  full_control user;

  remove_old "name='r_catalog_app_action'";

  p name       {val		r_catalog_app_action;};
  p id_parent  {getByName 	menu {f root;};};
  p class_name {val		app_action;};
};

class menu
{
  area usr;
  full_control root;
  full_control user;

  remove_old "name='l_catalog_app_action'";

  p name       {val		l_catalog_app_action;};
  p id_parent  {getByName 	menu {f root;};};
  p class_name {val		app_action;};
};

/* this is menu for right side on catalog form for sdoc*/
class menu
{
  area usr;
  full_control root;
  full_control user;

  remove_old "name='r_catalog_sdoc'";

  p name       {val		r_catalog_sdoc;};
  p id_parent  {getByName 	menu {f root;};};
  p class_name {val		sdoc;};
};

class menu
{
  area usr;
  full_control root;
  full_control user;

  remove_old "name='l_catalog_sdoc'";

  p name       {val		l_catalog_sdoc;};
  p id_parent  {getByName 	menu {f root;};};
  p class_name {val		sdoc;};
};

/* this is menu for right side on catalog form for sdoc_tag*/
class menu
{
  area usr;
  full_control root;
  full_control user;

  remove_old "name='r_catalog_sdoc_tag'";

  p name       {val		r_catalog_sdoc_tag;};
  p id_parent  {getByName 	menu {f root;};};
  p class_name {val		sdoc_tag;};
};

class menu
{
  area usr;
  full_control root;
  full_control user;

  remove_old "name='l_catalog_sdoc_tag'";

  p name       {val		l_catalog_sdoc_tag;};
  p id_parent  {getByName 	menu {f root;};};
  p class_name {val		sdoc_tag;};
};




/* menu_delete */
class js_code
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

   p code
   {
      val
      %%
       var par_area = COServer.getAreaName();
       
       ap_write("open_url('/co/asp/" + par_area + "/catalog?deleteItem"+
             "&active_area="+par_area+
             "&active_class="+context.active_class+
             "&active_item=" +context.active_item+
             "&active_path=" +context.active_path+
             "&version="+context.version+
             "&debug_level=0');");
      %%
      ;
    };
};    

class  menu_action
{
  area sys;
  area sec;
  area usr;


  full_control root;
  full_control user;

  remove_old "name='catalog_delete'";

   p name {val "catalog_delete";};
   p id_js_code {recent js_code;};
};

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_class;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_item;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_path;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val version;};
  p id_menu_action {recent menu_action;};
};  


class menu
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p name {val delete;};
  p class_name {val catalog;};
  p id_parent { getByName menu {f default_catalog;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_DELETE ;};
  p menu_position {val 200; };
};

class menu
{
  area sys;
  full_control root;
  full_control user;

  p name {val delete;};
  p class_name {val catalog;};
  p id_parent { getByName menu {f r_catalog_catalog;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_DELETE ;};
  p menu_position {val 200; };
};

class menu
{
  area sec;
  full_control root;
  full_control user;

  p name {val delete;};
  p class_name {val role;};
  p id_parent { getByName menu {f r_catalog_role;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_DELETE ;};
  p menu_position {val 200; };
};

class menu
{
  area usr;
  full_control root;
  full_control user;

  p name {val delete;};
  p class_name {val app_action;};
  p id_parent { getByName menu {f r_catalog_app_action;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_DELETE ;};
  p menu_position {val 200; };
};

class menu
{
  area usr;
  full_control root;
  full_control user;

  p name {val delete;};
  p class_name {val sdoc;};
  p id_parent { getByName menu {f r_catalog_sdoc;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_DELETE ;};
  p menu_position {val 200; };
};

class menu
{
  area usr;
  full_control root;
  full_control user;

  p name {val delete;};
  p class_name {val sdoc_tag;};
  p id_parent { getByName menu {f r_catalog_sdoc_tag;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_DELETE ;};
  p menu_position {val 200; };
};




/* end of delete */

/* menu_new */
class js_code
{
   area sys;
   area sec;
   area usr;

   full_control root;
   full_control user;

   p code
   {
      val
      %%
        var area = COServer.getAreaName();
        ap_write(
          "open_url('/co/asp/"+area+"/catalog?createItem" + 
                 "&active_area=" + area +
                 "&active_class="+ context.active_class+
                 "&active_item="+ context.active_item +
                 "&active_path=" +context.active_path +
                 "&debug_level=0');");
      %%
      ;
    };
};   

class  menu_action
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  remove_old "name='catalog_new'";

   p name {val catalog_new;};
   p id_js_code {recent js_code;};
};

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_class;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_item;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_path;};
  p id_menu_action {recent menu_action;};
};  


/* this is menu_item for default */
class menu
{
  area sys;
  full_control root;
  full_control user;

//  remove_old "name='new'";

  p name {val new;};
  p class_name {val catalog;};
  p id_parent { getByName menu {f default_catalog;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_INSERT_CHILD ;};
  p menu_position {val 100; };

};

class menu
{
  area sys;
  full_control root;
  full_control user;

  p name {val new;};
  p class_name {val catalog;};
  p id_parent { getByName menu {f l_catalog_catalog;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_INSERT_CHILD ;};
  p menu_position {val 100; };

};

class menu
{
  area sec;
  full_control root;
  full_control user;

  p name {val new;};
  p class_name {val role;};
  p id_parent { getByName menu {f l_catalog_role;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_INSERT_CHILD ;};
  p menu_position {val 100; };

};

class menu
{
  area usr;
  full_control root;
  full_control user;

  p name {val new;};
  p class_name {val app_action;};
  p id_parent { getByName menu {f l_catalog_app_action;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_INSERT_CHILD ;};
  p menu_position {val 100; };

};

class menu
{
  area usr;
  full_control root;
  full_control user;

  p name {val new;};
  p class_name {val sdoc;};
  p id_parent { getByName menu {f l_catalog_sdoc;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_INSERT_CHILD ;};
  p menu_position {val 100; };

};

class menu
{
  area usr;
  full_control root;
  full_control user;

  p name {val new;};
  p class_name {val sdoc_tag;};
  p id_parent { getByName menu {f l_catalog_sdoc_tag;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_INSERT_CHILD ;};
  p menu_position {val 100; };

};

/* end of new */

/* menu_trash */
class js_code
{
   area sys;
   area sec;
   area usr;

   full_control root;
   full_control user;

   p code
   {
      val
      %%
        var par_area = COServer.getAreaName();
        ap_write("open_url('/co/asp/" + par_area + "/catalog?trash" + 
                 "&active_area="+ par_area+
                 "&active_class="+ context.active_class+
                 "&active_item="+context.active_item+
                 "&active_path=" +context.active_path+
                 "&debug_level=0');");
      %%
      ;
    };
};   

class  menu_action
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  remove_old "name='catalog_trash'";

   p name {val catalog_trash;};
   p id_js_code {recent js_code;};
};

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_class;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_item;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_path;};
  p id_menu_action {recent menu_action;};
};  


/* this is menu_item for default */
class menu
{
  area sys;
  full_control root;
  full_control user;

//  remove_old "name='new'";

  p name {val trash;};
  p class_name {val catalog;};
  p id_parent { getByName menu {f default_catalog;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_UNDELETE ;};
  p menu_position {val 300; };

};

class menu
{
  area sys;
  full_control root;
  full_control user;

  p name {val trash;};
  p class_name {val catalog;};
  p id_parent { getByName menu {f l_catalog_catalog;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_UNDELETE ;};
  p menu_position {val 300; };

};

class menu
{
  area sec;
  full_control root;
  full_control user;

  p name {val trash;};
  p class_name {val role;};
  p id_parent { getByName menu {f l_catalog_role;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_UNDELETE ;};
  p menu_position {val 300; };
};

class menu
{
  area usr;
  full_control root;
  full_control user;

  p name {val trash;};
  p class_name {val app_action;};
  p id_parent { getByName menu {f l_catalog_app_action;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_UNDELETE ;};
  p menu_position {val 300; };
};

class menu
{
  area usr;
  full_control root;
  full_control user;

  p name {val trash;};
  p class_name {val sdoc;};
  p id_parent { getByName menu {f l_catalog_sdoc;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_UNDELETE ;};
  p menu_position {val 300; };
};

class menu
{
  area usr;
  full_control root;
  full_control user;

  p name {val trash;};
  p class_name {val sdoc_tag;};
  p id_parent { getByName menu {f l_catalog_sdoc_tag;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_UNDELETE ;};
  p menu_position {val 300; };
};
/* end of trash */

/* menu_go! */
class js_code
{
   area sys;
   area sec;
   area usr;

   full_control root;
   full_control user;

   p code
   {
      val
      %%
        var par_area = COServer.getAreaName();

        // we read items data
        var meta = new class_meta_class(par_area);
        var cat = eval("new class_" + context.active_class + "('" + par_area + "');"); 
        var rs =  cat.getItemData(context.active_item);
        var type_class_name = rs.getValueByName(0, "type_class_name");

        if (type_class_name!="attachment")
	{
	 // we take default form for items class
         var default_form = meta.getDefaultFormByName( -1 , type_class_name);
 
         // we ask to open window with default form
         ap_write("open_url('/co/html/" + par_area+ "/" + type_class_name+"?" + default_form +
                 "&par_area="+ par_area + 
                 "&par_class="+ type_class_name+
                 "&par_id="+rs.getValueByName(0,"id_item")+
                 "&active_path=" +context.active_path+
                 "&debug_level=0');");
        }
        else
	{
	 //ap_write("open_url('/co/attachment/data/"+
	 //           rs.getValueByName(0,"id_item")+"/"+
	 //	   rs.getValueByName(0,"name")+"');");
	 ap_write("open_url('/co/html/sys/attachment?getFile&par_id="+
	             rs.getValueByName(0,"id_item")+"');");
	}
      %%
      ;
    };
};

class  menu_action
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  remove_old "name='catalog_go'";

   p name {val catalog_go;};
   p id_js_code {recent js_code;};
};

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_class;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_item;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_path;};
  p id_menu_action {recent menu_action;};
};  


/* this is menu_item for default */
class menu
{
  area sys;
  full_control root;
  full_control user;

//  remove_old "name='new'";

  p name {val go;};
  p class_name {val catalog;};
  p id_parent { getByName menu {f default_catalog;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_GET ;};
  p menu_position {val 100; };

};

class menu
{
  area sys;
  full_control root;
  full_control user;

  p name {val go;};
  p class_name {val catalog;};
  p id_parent { getByName menu {f r_catalog_catalog;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_GET ;};
  p menu_position {val 100; };

};

class menu
{
  area sec;
  full_control root;
  full_control user;

  p name {val go;};
  p class_name {val role;};
  p id_parent { getByName menu {f r_catalog_role;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_GET ;};
  p menu_position {val 100; };

};

class menu
{
  area usr;
  full_control root;
  full_control user;

  p name {val go;};
  p class_name {val app_action;};
  p id_parent { getByName menu {f r_catalog_app_action;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_GET ;};
  p menu_position {val 100; };
};

class menu
{
  area usr;
  full_control root;
  full_control user;

  p name {val go;};
  p class_name {val sdoc;};
  p id_parent { getByName menu {f r_catalog_sdoc;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_GET ;};
  p menu_position {val 100; };
};

class menu
{
  area usr;
  full_control root;
  full_control user;

  p name {val go;};
  p class_name {val sdoc_tag;};
  p id_parent { getByName menu {f r_catalog_sdoc_tag;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_GET ;};
  p menu_position {val 100; };
};


/* end of go! */



/* menu_attach! */
class js_code
{
   area sys;
   full_control root;
   full_control user;

   p code
   {
      val
      %%
        var par_area = 'sys';

        // we read items data
        var meta = new class_meta_class(par_area);
        var cat = new class_catalog(par_area); 
        var rs =  cat.getItemData(context.active_item);
        var type_class_name = "attachment";

        // we take default form for items class
        var default_form = meta.getDefaultFormByName( -1, type_class_name);

        // we ask to open window with default form
        ap_write("open_url('/co/html/sys/" + type_class_name+"?" + default_form +
                 "&par_area="+ par_area +
                 "&par_class=catalog" +
                 "&par_id=" + context.active_item +
		 "&active_path=" + context.active_path +
                 "&debug_level=0');");
      %%
      ;
    };
};

class  menu_action
{
  area sys;
  full_control root;
  full_control user;

  remove_old "name='catalog_attach'";

   p name {val catalog_attach;};
   p id_js_code {recent js_code;};
};

class menu_action_param
{
  area sys;
  full_control root;
  full_control user;

  p param_name {val active_class;};
  p id_menu_action {recent menu_action;};
};

class menu_action_param
{
  area sys;
  full_control root;
  full_control user;

  p param_name {val active_item;};
  p id_menu_action {recent menu_action;};
};

class menu_action_param
{
  area sys;
  full_control root;
  full_control user;

  p param_name {val active_path;};
  p id_menu_action {recent menu_action;};
};


/* this is menu_item for default */
class menu
{
  area sys;
  full_control root;
  full_control user;

//  remove_old "name='new'";

  p name {val attach;};
  p class_name {val catalog;};
  p id_parent { getByName menu {f default_catalog;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_INSERT_CHILD ;};
  p menu_position {val 300; };

};

class menu
{
  area sys;
  full_control root;
  full_control user;

  p name {val attach;};
  p class_name {val catalog;};
  p id_parent { getByName menu {f l_catalog_catalog;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_INSERT_CHILD ;};
  p menu_position {val 300; };

};

/* end of attach */

/* menu_permissions */
class js_code
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

   p code
   {
      val
      %%
       var par_area = COServer.getAreaName();
 
       ap_write("open_url('/co/asp/" + par_area + "/catalog?setACL"+
             "&active_area="+par_area+
             "&active_class="+context.active_class+
             "&active_item=" +context.active_item+
             "&active_path=" +context.active_path+
             "&version="+context.version+
             "&debug_level=0');");
      %%
      ;
    };
};    

class  menu_action
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  remove_old "name='catalog_permissions'";

   p name {val catalog_permissions;};
   p id_js_code {recent js_code;};
};

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_class;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_item;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_path;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val version;};
  p id_menu_action {recent menu_action;};
};  


class menu
{
  area sys;
  full_control root;
  full_control user;

  p name {val permissions;};
  p class_name {val catalog;};
  p id_parent { getByName menu {f default_catalog;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_CHANGE_ACL ;};
  p menu_position {val 300; };

};

class menu
{
  area sys;
  full_control root;
  full_control user;

  p name {val permissions;};
  p class_name {val catalog;};
  p id_parent { getByName menu {f r_catalog_catalog;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_CHANGE_ACL ;};
  p menu_position {val 300; };

};

class menu
{
  area sec;
  full_control root;
  full_control user;

  p name {val permissions;};
  p class_name {val role;};
  p id_parent { getByName menu {f r_catalog_role;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_CHANGE_ACL ;};
  p menu_position {val 300; };

};

class menu
{
  area usr;
  full_control root;
  full_control user;

  p name {val permissions;};
  p class_name {val app_action;};
  p id_parent { getByName menu {f r_catalog_app_action;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_CHANGE_ACL ;};
  p menu_position {val 300; };

};

class menu
{
  area usr;
  full_control root;
  full_control user;

  p name {val permissions;};
  p class_name {val sdoc;};
  p id_parent { getByName menu {f r_catalog_sdoc;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_CHANGE_ACL ;};
  p menu_position {val 300; };

};

class menu
{
  area usr;
  full_control root;
  full_control user;

  p name {val permissions;};
  p class_name {val sdoc_tag;};
  p id_parent { getByName menu {f r_catalog_sdoc_tag;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_CHANGE_ACL ;};
  p menu_position {val 300; };

};
/* end of permission */


/* menu edit */
class js_code
{
   area sys;
   area sec;
   area usr;

   full_control root;
   full_control user;

   p code
   {
      val
      %%
        var par_area = COServer.getAreaName();

        ap_write("open_url('/co/html/" + par_area+ "/" + context.active_class +"?showForm"  +
                 "&par_area=" + par_area + 
                 "&par_class="+ context.active_class +
                 "&par_id="   + context.active_item +
                 "&active_path=" +context.active_path+
                 "&deep_level=1" + 
                 "&debug_level=0');");
     %%
      ;
    };
};

class  menu_action
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  remove_old "name='catalog_edit'";

   p name {val catalog_edit;};
   p id_js_code {recent js_code;};
};

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_class;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_item;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_path;};
  p id_menu_action {recent menu_action;};
};  


/* this is menu_item for default */
class menu
{
  area sys;
  full_control root;
  full_control user;

//  remove_old "name='new'";

  p name {val edit;};
  p class_name {val catalog;};
  p id_parent { getByName menu {f default_catalog;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_GET ;};
  p menu_position {val 100; };

};

class menu
{
  area sys;
  full_control root;
  full_control user;

  p name {val edit;};
  p class_name {val catalog;};
  p id_parent { getByName menu {f r_catalog_catalog;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_GET ;};
  p menu_position {val 100; };

};


/* end of edit */

/* menu cut */
class js_code
{
   area sys;
   area sec;
   area usr;

   full_control root;
   full_control user;

   p code
   {
      val
      %%
        var par_area = COServer.getAreaName();
		var cat = eval( "new class_"+context.active_class+"('"+par_area+"')");
		cat.cut(context.active_item);
      %%
      ;
    };
};

class  menu_action
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  remove_old "name='catalog_cut'";

   p name {val catalog_cut;};
   p id_js_code {recent js_code;};
};

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_class;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_item;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_path;};
  p id_menu_action {recent menu_action;};
};  


/* this is menu_item for default */
class menu
{
  area sys;
  full_control root;
  full_control user;

//  remove_old "name='new'";

  p name {val cut;};
  p class_name {val catalog;};
  p id_parent { getByName menu {f default_catalog;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_GET ;};
  p menu_position {val 100; };

};

class menu
{
  area sys;
  full_control root;
  full_control user;

  p name {val cut;};
  p class_name {val catalog;};
  p id_parent { getByName menu {f r_catalog_catalog;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_DELETE ;};
  p menu_position {val 100; };

};

/* end of cut */

/* menu paste */
class js_code
{
   area sys;
   area sec;
   area usr;

   full_control root;
   full_control user;

   p code
   {
      val
      %%
        var par_area = COServer.getAreaName();
		var cat = eval( "new class_"+context.active_class+"('"+par_area+"')");
		cat.paste(context.active_item);
      %%
      ;
    };
};

class  menu_action
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  remove_old "name='catalog_paste'";

   p name {val catalog_cut;};
   p id_js_code {recent js_code;};
};

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_class;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_item;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;
  area sec;
  area usr;

  full_control root;
  full_control user;

  p param_name {val active_path;};
  p id_menu_action {recent menu_action;};
};  


/* this is menu_item for default */
class menu
{
  area sys;
  full_control root;
  full_control user;

//  remove_old "name='new'";

  p name {val paste;};
  p class_name {val catalog;};
  p id_parent { getByName menu {f default_catalog;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_INSERT_CHILD ;};
  p menu_position {val 100; };

};

class menu
{
  area sys;
  full_control root;
  full_control user;

  p name {val paste;};
  p class_name {val catalog;};
  p id_parent { getByName menu {f l_catalog_catalog;};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_INSERT_CHILD ;};
  p menu_position {val 100; };

};

/* end of cut */




}; // end file menu_catalog
