#include "../../include/types.t"      
#include "../../include/defines.t"      

// CLASS CATALOG

class catalog_root
{ 
  
  doc "in this class we keep information about roots for roles and catalogs";
  
  area "sec";
  area "sys";
  area "usr";

#include "../../include/check_acl.t"
  
  inherits generic_acl;
  
  container_class 'role';
  container_column_name 'id_role';
      
 // PROPERTIES
      
#include "../../include/generic_acl_props.t"      

  prop id_role
  {      
    type CO_INTEGER;      
    default 0;      
    params '';      
    representant 1;      
    foreign 'role';      
    foreign_prop 'id';      
    position 200;    
  };    

  prop class_name
  {      
    type CO_STRING;      
    default "''";      
    params '';      
    representant 1;      
    foreign 'meta_class';      
    foreign_prop 'class_name';      
    position 200;    
  };    
   
  prop root_name
  {      
    type CO_STRING;      
    default "''";      
    params '';      
    representant 1;      
    foreign '';      
    foreign_prop '';      
    position 200;    
  };    
 
  prop id_root
  {
    type CO_INTEGER;
    default 0;
    params '';
    representant 1;
    foreign '';
    foreign_prop '';
    position 300;
  };
 
 method getIdRoot
  {
     doc "this method is used to get id_root for given catalog type and current user";

     id_permission __PERMISSION_SELECT;
     sec_type __METHOD_SEC_TYPE_CLASS;
 
     __PARAMS_HEADER_WITH_CALLBACK
     param class_name
     {
       doc "this is the name of the base class for catalog for which you ask to get id_root";
       type CO_STRING;
     };
 
     declare language_c
     {
        C "int id_root;";
     };
 
     body language_c
     {
       C
       %%
       __SQL_GET_INTEGER(id_root,"SELECT id_root, root_name FROM co_%s_catalog_root WHERE class_name = '%s' AND id_role = %d",
                       par_area, class_name, cnx->id_role);
       __CREATE_JS_FROM_INTEGER(id_root);
       __RETURN_INTEGER(id_root);
       %%
       ;
     };
  };

 
};

//END OF CLASS CATALOG_ROOT