
#include "../../include/types.t"
#include "../../include/defines.t"

#define __PARAMS_HEADER2 __PARAMS_HEADER
    
class meta_class
{
   
	area usr
	{
		force_sec_type 1;
	};
	area sys
	{
		force_sec_type 1;
	};

	area sec
	{
		force_sec_type 1;
	};

#include "../../include/check_acl.t"
   
   container_class '';
   container_column_name '';

#include "../../include/generic_acl_props.t"    

   prop class_name
   {
     type CO_STRING;
     default "''";
     params '';
     representant 1;
     foreign '';
     foreign_prop '';
     position 200;
   };
   
   prop inherits_from
   {
     type CO_STRING;
     default "''";
     params '';
     representant 1;
     foreign '';
     foreign_prop '';
     position 200;

   };
   
   prop container_class
   {
     type CO_STRING;
     default "''";
     params '';
     representant 1;
     foreign '';
     foreign_prop '';
     position 200;

   };

   prop container_column_name
   {
     type CO_STRING;
     default "''";
     params '';
     representant 1;
     foreign '';
     foreign_prop '';
     position 200;

   };

   prop default_form
   {
     type CO_STRING;
     default "''";
     params '';
     representant 1;
     foreign '';
     foreign_prop '';
     position 200;

   };
 
   prop sec_type
   {
     type CO_INTEGER;
     default 0;
     params 'VALUES=new Array(0,1);';
     representant 0;
     foreign '';
     foreign_prop '';
     position 220;
   };


   prop force_sec_type
   {
     type CO_INTEGER;
     default 0;
     params 'VALUES=new Array(0,1);';
     representant 0;
     foreign '';
     foreign_prop '';
     position 220;
   };

                   
   inherits generic_acl;
   
  method getDefaultFormByName
  {
     id_permission __PERMISSION_SELECT;
     sec_type __METHOD_SEC_TYPE_CLASS;
   
     __PARAMS_HEADER_WITH_CALLBACK
     param class_name {type CO_STRING;};
     
     declare language_c
     {
        C 'char * default_form;';
        C 'char * inherits_from;';
     };

     body language_c
     {
         C 
         %%
	  default_form = ap_pstrdup(p, "");
          inherits_from = ap_pstrdup(p, class_name);
	  if( !(strlen(inherits_from) > 2) ) cou_error( cnx, "class_name shorter thar 3 chars");
	  corec = NULL;
          while ( (strlen(default_form) == 0) && (strlen(inherits_from) > 2) )
          {
             __CREATE_QUERY("SELECT default_form, inherits_from FROM co_%s_meta_class WHERE class_name='%s'" , par_area, inherits_from);
             __SQL_GET_RESULT
             if(cor_GetTupleCount(cnx, corec) != 1)
             {
                cou_sendMessageX(cnx, ap_psprintf(p, "getDefaultFormByName: zla nazwa klasy bazowa: '%s' obecna: '%s'", class_name, inherits_from), CO_MSG_FORCE);
                cou_setReturnValue(cnx, ap_pstrdup(p, ""), CO_STRING);
                return -1;
             }; 
             default_form =  cor_GetCopyOfValue(cnx, corec, 0,0);
             inherits_from = cor_GetCopyOfValue(cnx, corec, 0,1);
          };
          cou_sendMessageX(cnx, ap_psprintf(p, "SEND_DATA: %d", cnx->send_data), CO_MSG_DEBUG);
          __CREATE_JS
          cou_setReturnValue(cnx, default_form, CO_STRING);
         %%
         ; 
      };  
								    
  };

  method getFullPathByClassName
  {
     doc 
        %%
This method returns names for all classes that given class inherits from -- full path. Names are separated by '|'
Typical result: generic|generic_acl|catalog|  
        %%
     {
         pl 
         %%
Ta metoda zwraca nazwy wszystkich klas, z ktorych dziedziczy dana klasa -- pelna sciezka. Nazwy sa rozdzielane przez znak 'I'
Przykladowy wynik: generic|generic_acl|catalog
         %%
         ;  
     };

     id_permission __PERMISSION_SELECT;
     sec_type __METHOD_SEC_TYPE_CLASS;
   
     __PARAMS_HEADER_WITH_CALLBACK
     param class_name {type CO_STRING;};
     
     declare language_c
     {
        C 'char * path;';
     };

     body language_c
     {
         C 
         %%
       path = ap_pstrdup(p, "");
       __SQL_GET_STRING(path,"SELECT getpathx('%s','meta_class', 'class_name', 'inherits_from', 'class_name','|','generic', '%s')",
                                            par_area, class_name)
       cou_setReturnValue(cnx, path, CO_STRING);
       __CREATE_JS_FROM_STRING(path);
        %%
         ; 
      };  
								    
  };



   function_sql add
   {
     params "(text,text,text,text)";
     returns int;

// we treat this like perl code to substitute ${name_area} with current area name     
// that is why we have to escpae $ in declaration block
     
     S 
     %%
     @"
      DECLARE
       _class_name ALIAS FOR \$1;
       _inherits_from alias for \$2;
       _container_class alias for \$3;
       _container_column alias for \$4;
      BEGIN
       delete from co_${name_area}_meta_class where class_name = _class_name;
       insert into co_${name_area}_meta_class(class_name, inherits_from, container_class, container_column_name)
	   values(_class_name, _inherits_from, _container_class, _container_column);
	    
       RETURN 1;
      END;
      "
     %%
     ;
   };     
   
   
   
   
};  
