// TYPES FOR CO

#include "types.t"
#include "defines.t"

// CLASS picture

class picture
{
  inherits file;

  container_class "";
  container_column_name "";

  area sys;
  area usr;

#include "../../include/check_acl.t"

  include_c "http_protocol.h";
  include_c "co_mod.h";
  include_c "../coffice/mod_coffice.h";

  uses "generic";
  uses "file";

/* mapping files into memory */
  include_c "stdlib.h";
  include_c "unistd.h";
  include_c "sys/mman.h";
  include_c "fcntl.h";

 // PROPERTIES
#include "generic_acl_props.t"

 prop format
 {
   type CO_STRING;
   default "'bmp'";
   params '';
   representant 1;
   foreign '';
   foreign_prop '';
   position 44;
 };

 // METHODS

  method getContentType
  {
    doc "Returns string containing content type.";
    id_permission __PERMISSION_GET;
    __PARAMS_HEADER

    declare language_c
    {
     C
     %%
     const char *image_format = "";
     %%
     ;
    };
    
    body language_c
    {
     C
     %%
	__SQL_GET_STRING(image_format,"select format from co_%s_%s
				       where id=%d",par_area,par_class,par_id)

        cou_setReturnValue( cnx, 
	    ap_psprintf(p, "image/%s", image_format),
	    CO_STRING
	);

     %%
     ;
    };
  };

  method convertTo
  {
    doc "converts bitmap picture to given format (nicht immer)";
    id_permission __PERMISSION_UPDATE;

    __PARAMS_HEADER
    param new_format { type CO_STRING; };


    declare language_c
    {
      C
      %%
      const char *image_format = "";

      char *partial_path;
      char *source_file_path;
      char *destination_file_path;

      char *bash_command;
      %%
      ;
    };

    body language_c
    {
      C
      %%
      __SQL_GET_STRING(image_format,"select format from co_%s_picture
    			             where id=%d",par_area,par_id)

      // can convert only from bmp format
      if ((!strcmp(image_format,"bmp")) && (strcmp(new_format,"bmp")))
      {
        @co_call(par_area,par_class,'getPath',par_id=>par_id,par_area=>par_area,par_class=>par_class);
        partial_path = cou_getReturnValue( cnx, CO_STRING, &err);
        source_file_path = ap_psprintf( p, "%s/%s", cou_getCODataPath(), partial_path);
	destination_file_path = ap_psprintf( p, "/tmp/picture.%d", par_id);

	bash_command = ap_psprintf(p,"%stoppm %s | ppmto%s > %s",image_format,source_file_path,new_format,destination_file_path);

        __SEND_MESG_DEBUG("bash_command = %s",bash_command)

	system(bash_command);

        rename(destination_file_path,source_file_path);

	__CREATE_QUERY("update co_%s_picture set format='%s'
                      where id=%d",par_area,new_format,par_id)
        __SQL_EXEC
       }

      %%
      ;
    };
  };

  method toGIF
  {
    doc "converts bitmap picture to gif format";
    id_permission __PERMISSION_UPDATE;

    __PARAMS_HEADER

    declare language_c
    {
      C
      %%
      const char *image_format = "";

      char *partial_path;
      char *source_file_path;
      char *destination_file_path;

      char *bash_command;
      %%
      ;
    };

    body language_c
    {
      C
      %%
      __SQL_GET_STRING(image_format,"select format from co_%s_%s
    			             where id=%d",par_area,par_class,par_id)

      // can convert only from bmp format
      if (!strcmp(image_format,"bmp"))
      {
        @co_call(par_area,par_class,'getPath',par_id=>par_id,par_area=>par_area,par_class=>par_class);
        partial_path = cou_getReturnValue( cnx, CO_STRING, &err);
        source_file_path = ap_psprintf( p, "%s/%s", cou_getCODataPath(), partial_path);
	destination_file_path = ap_psprintf( p, "/tmp/picture.%d", par_id);

	bash_command = ap_psprintf(p,"%stoppm %s | ppmtogif > %s",image_format,source_file_path,destination_file_path);

	system(bash_command);

	__CREATE_QUERY("update co_%s_%s set format='gif'
                      where id=%d",par_area,par_class,par_id)

        __SQL_EXEC

        @co_call(par_area,par_class,'getPath',par_id=>par_id,par_area=>par_area,par_class=>par_class);

        partial_path = cou_getReturnValue( cnx, CO_STRING, &err);
        source_file_path = ap_psprintf( p, "%s/%s", cou_getCODataPath(), partial_path);

        rename(destination_file_path,source_file_path);

       }

      %%
      ;
    };
  };

};