@perl use co_modules_functions;

@perl $user = $ENV{"USER"};

@foreach item_list

  @// Building type mapping table
  @perl @co_type_map;
  @foreach type
    @perl @${c_type}[0]->visit ();  
    @perl @${pointer}[0]->visit ();  
    @perl @${is_array}[0]->visit ();  
    @perl @${sql_type}[0]->visit ();    
    @perl $co_type_map[0]{$name_type} = { "c_type" => $name_c_type, "pointer" => $name_pointer, "is_array" => $name_is_array, "sql_type"=>$name_sql_type};
    
  @end    


  @// creating *.sql files
  @foreach class
  @foreach area

  @openfile co_create_${name_area}_${name_class}.sql
  
/******************************************************************/
/*                                                                */ 
/* CREATION OF co_${name_area}_${name_class};                     */
/*                                                                */
/******************************************************************/

    @foreach sequence
      drop sequence co_${name_area}_${name_class}_${name_sequence}
      !NOERROR
      create sequence co_${name_area}_${name_class}_${name_sequence} start 1
      !GO
      grant all on co_${name_area}_${name_class}_${name_sequence} to nobody
      !GO
    @end .. sequence

  drop table co_${name_area}_${name_class}
  !NOERROR
  create table co_${name_area}_${name_class}
  (
    @perl $i=0;  
    @foreach prop

      @perl #first we check whether this is function or normal prop
      @perl $is_function=0;
      @foreach f_body
         @perl $is_function =1;
      @end 
      @perl if($is_function) {
      @perl } # end for function -- we do nothing
      @perl else{  
      @perl if ($i != 0) {
        ,
      @perl }
      @perl $i++;
      @perl @${type}[0]->visit ();
      @perl $sql_type = $co_type_map[0]{$name_type}->{"sql_type"};
      $name_prop  $sql_type default
      @foreach default
        @perl if($name_default eq "SEQUENCE") {
         @foreach sq_name
           nextval('co_${name_area}_${name_class}_${name_sq_name}'::text)
         @end .. name
        @perl }else{
           $name_default
        @perl } 
      @end .. default	
      @perl } # end for else is_function 
    @end .. prop

  )
  !GO
  grant all on co_${name_area}_${name_class} to nobody
  !GO
  
  @foreach index
    DROP INDEX co_${name_area}_${name_class}_${name_index}
    !NOERROR
    
    CREATE 
    @foreach unique
     @perl if($name_unique == 1) {
      UNIQUE
     @perl } 
    @end .. unique
    INDEX co_${name_area}_${name_class}_${name_index}
    ON co_${name_area}_${name_class}
    ( 
    @perl $i=0;  
    @foreach column
      $name_column
      @perl if ($i != $#${column}) {
        ,
      @perl }
      @perl $i++;
    @end .. column
    )
    !GO
    
  @end .. index
  
  @openfile co_init_${name_area}_${name_class}.sql

  @perl @${inherits}[0]->visit ();
  @perl @${container_class}[0]->visit ();
  @perl @${container_column_name}[0]->visit ();

  
  select co_${name_area}_meta_class_add('$name_class', '$name_inherits' , '$name_container_class', '$name_container_column_name')
  !SELECT

  @foreach default_form
    UPDATE co_${name_area}_meta_class SET default_form = '$name_default_form' WHERE class_name = '$name_class'
    !GO
  @end .. default_form

DELETE FROM co_${name_area}_meta_prop WHERE class_name='$name_class'
!GO
    @foreach prop
      @perl @${type}[0]->visit ();
      @perl @${params}[0]->visit ();
      @perl @${representant}[0]->visit ();
      @perl @${foreign}[0]->visit ();
      @perl @${foreign_prop}[0]->visit ();
      @perl @${position}[0]->visit ();

insert into co_${name_area}_meta_prop(class_name, prop_name, prop_params, prop_representant, prop_foreign, prop_foreign_prop, prop_position, prop_type)
  values('$name_class', '$name_prop','$name_params','$name_representant','$name_foreign','$name_foreign_prop','$name_position','$name_type')
!GO  
 
		    
    @end .. prop

DELETE FROM co_${name_area}_meta_method WHERE class_name='$name_class'
!GO

    @foreach method
      @foreach id_permission
      @openfile co_init_${name_area}_${name_class}.sql -append
insert into co_${name_area}_meta_method(class_name, method_name, id_permission)
            values('$name_class', '$name_method','$name_id_permission')
!GO
      @end
      @foreach profiled
      @openfile co_init_${name_area}_${name_class}.sql -append
update co_${name_area}_meta_method set profiled=1
where class_name='$name_class' and method_name='$name_method'
!GO
      @perl undef($profiled_i);
      @end .. profiled
      @perl undef(@${profiled});
      @foreach server_event
	@foreach execute_jscript
	@perl $name_execute_jscript =~ s/([\"|\'|\\])/\\\1/g;
  @openfile co_init_${name_area}_${name_class}.sql -append
insert into co_${name_area}_js_code(code) values('${name_execute_jscript}')
!GO
update co_${name_area}_meta_method
set id_${name_server_event}_script=(select last_value from co_${name_area}_js_code_sqid)
where class_name='$name_class' and method_name='$name_method'
!GO
	@end .. execute_jscript
        @foreach execute
          @perl @${class_name}[0]->visit ();
          @perl @${method_name}[0]->visit ();
  @openfile co_initv_${name_area}_${name_class}.sql -append
update co_${name_area}_meta_method
set id_${name_server_event}_method=
(select id from co_${name_area}_meta_method
 where class_name='${name_class_name}' and method_name='${name_method_name}')
where class_name='${name_class}' and method_name='${name_method}'
!GO
        @end .. execute
        @perl undef($server_event_i);
      @end .. server_event
      @perl undef(@${server_event});
    @end .. method

  @openfile co_initv_${name_area}_${name_class}.sql -append
/* now we generate entries for vtable */
select co_${name_area}_meta_vtable_generate('${name_class}')
!SELECT
@openfile co_functions_${name_area}_${name_class}.sql  
/******************************************************************/
/*                                                                */ 
/* CREATION OF SQL FUNCTIONS FOR co_${name_area}_${name_class};                     */
/*                                                                */
/******************************************************************/

  @foreach function_sql
    DROP FUNCTION co_${name_area}_${name_class}_${name_function_sql}
     @foreach params
       $name_params
     @end .. params
     !NOERROR
     
    CREATE FUNCTION  co_${name_area}_${name_class}_${name_function_sql}
    @foreach params
       $name_params
    @end .. params
    RETURNS
    @foreach returns
      $name_returns
    @end .. returns
    AS '
    @foreach S
      @// lines starting with @ we treat as perl code
      @perl if($name_S =~ s/^\s*\@//) {
      @perl my($temp) = eval($name_S);
      @// split staff is to have nice looking code
      @perl my(@temp) = split "\n", $temp;
      @perl foreach $t (@temp) {
$t
      @perl }}else{
      @perl my(@temp) = split "\n", $name_S;
      @perl foreach $t (@temp) { $t =~ s/^(\s+)//;
      @perl if($t =~ s/^\@//) {
      @perl my($temp) = eval($t);
       
      @// split staff is to have nice looking code
      @perl my(@temp) = split "\n", $temp;
      @perl foreach $t (@temp) {
$t
      @perl }}else{
$t
      @perl} } }
   @end .. S
    ' LANGUAGE 'plpgsql'
    !GO
    
  @end .. function_sql
  
  @foreach prop
      @perl $is_function=0;
      @foreach f_body
        $name_f_body
        @perl $is_function = 1;
      @end 
      @perl if( not $is_function) {
 
      @perl @${type}[0]->visit ();
      @perl $sql_type = $co_type_map[0]{$name_type}->{"sql_type"};

     DROP FUNCTION lhlo_${name_area}_${name_class}_${name_prop}(${sql_type})
     !NOERROR

     CREATE FUNCTION lhlo_${name_area}_${name_class}_${name_prop}(${sql_type}) RETURNS co_${name_area}_${name_class} AS
     '
        SELECT * FROM co_${name_area}_${name_class} WHERE co_${name_area}_${name_class}.${name_prop} = \$1
     '
     LANGUAGE 'sql'
     !GO
     @perl } #end of if not is_function
  @end .. prop

    @foreach prop
      @perl #first we check whether this is function or normal prop
      @perl $is_function=0;
      @foreach f_body
        @perl $is_function = 1;
      @end 
      @perl if($is_function) {
      @perl @${type}[0]->visit ();
      @perl $sql_type = $co_type_map[0]{$name_type}->{"sql_type"};
     DROP FUNCTION cof_${name_area}_${name_class}_${name_prop}(co_${name_area}_${name_class}_${name_prop})
     !NOERROR

     CREATE FUNCTION  cof_${name_area}_${name_class}_${name_prop}(co_${name_area}_${name_class}_${name_prop})
            RETURNS $sql_type AS
     '
            $name_function
     '
     LANGUAGE 'sql'
     !GO
      @perl } # end for if is_function 
    @end .. prop
 
  @end .. area
  @end .. class
  
@end .. item_list
