
#include "types.t"
#include "defines.t"

#define __PARAMS_HEADER2 __PARAMS_HEADER
    
class user
{
   
   area sec;

#include "../../include/check_acl.t"
   
   container_class 'role';
   container_column_name 'id';

#include "generic_acl_props.t" 
  
   index login
   {
     unique 1;
     column login;
   };

   prop id_role
   {
     type CO_INTEGER;
     default 0;
     params 
  %%

READONLY=1;
EXTRA_FILTER="id_catalog_type|=|1";

  %%
  ;
     representant 1;
     foreign 'role';
     foreign_prop 'id';
     position 100;
   };

//    login text NOT NULL UNIQUE,
//    passwd text NOT NULL,

   prop login
   {
     type CO_STRING;
     default "''";
     params '';
     representant 1;
     foreign '';
     foreign_prop '';
     position 200;
   };

   prop passwd
   {
     type CO_STRING;
     default "''";
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 200;
   };

   prop name
   {
     type CO_STRING;
     default "''";
     params '';
     representant 1;
     foreign '';
     foreign_prop '';
     position 200;
   };

   prop description
   {
     type CO_STRING;
     default "''";
     params '';
     representant 1;
     foreign '';
     foreign_prop '';
     position 200;
   };
#if 0
   prop id_preference
   {
     doc "User preferences";
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign 'preference';
     foreign_prop 'id';
     position 100;
   };
#endif

   inherits generic_acl;
   default_form "showForm&deep_level=1";

   include_c "co_priv_salt.c";

   uses "generic_acl";
   uses "generic";

 method update
 {
   id_permission __PERMISSION_UPDATE;
   sec_type __METHOD_SEC_TYPE_OBJECT;

   doc "This method updates one prop of one object. Sends action CO_OP_UPDATE. If id_role is being updated,";
   doc "wrapper role of this user is moved to new parent role.";
   doc "WARNING: this code assumes that: 1. every user has its wrapper role; 2. id_item uniquely defines role (at least for id_item=some id of user)."
   {
     pl "Ta metoda zmienia jedno property danego obiektu. Wysya akcje CO_OP_UPDATE. Jeli aktualizowane jest id_role,";
     pl "to rola reprezentujca danego uytkownika zostaje przeniesiona do nowej roli-katalogu.";
     pl "UWAGA: zakadamy, e: 1. kady user ma reprezentujc go rol; 2. id_item jednoznacznie okrela rol (co najmniej dla id_item=jakie id usera).";
   };

    __PARAMS_HEADER_WITH_VERSION
    param par_prop
    {
      type CO_STRING;
      doc "Name of the prop to be updated"
      {
         pl "Nazwa prop, ktoremu bedzie zmieniona wartosc";
      };
    };
    param new_value
    {
      type CO_STRING;
      doc "New value for prop. All values are passed as CO_STRING type!"
      {
         pl "Nowa wartosc. Wszystkie wartosci sa przekazywane jako typ CO_STRING !";
      };
    };

    declare language_c
    {
       C 'int id_wrapper_role;';
       C 'char * id_user;';
    };

    body language_c
    {
      C
      %%
		/* bla bla bla */
        @co_call(par_area,'"generic_acl"',"update",par_area=>par_area,par_class=>par_class,par_id=>par_id,par_prop=>par_prop,new_value=>new_value,version=>version);

		if (strcmp(par_prop, "id_role")==0) {
			/* find wrapper for this user */
			id_user=ap_psprintf(p, "%d", par_id); /* conver to string */
        	@co_call(par_area,par_class,"getByProp",par_area=>par_area,par_class=>'"role"',par_id=>-1,prop_name=>'"id_item"',prop_val=>id_user);
			cou_logError(cnx, CO_LOG_DEBUG, "getByProp returned");
			__GET_RETURNED_RECORDSET(corec)
			id_wrapper_role = atoi(cor_GetCopyOfValueByName(cnx, corec, 0, "id"));
			cou_logError(cnx, CO_LOG_DEBUG, "Clearing result");
			__CLEAR_RESULT /* clears corec */
			cou_logError(cnx, CO_LOG_DEBUG, "...cleared.");
			/* update its parent role: set id_parent to the value of id_role set in user */
        	@co_call(par_area,'"role"',"update",par_area=>par_area,par_class=>'"role"',par_id=>id_wrapper_role,par_prop=>'"id_parent"',new_value=>new_value,version=>-1);
		}

      %%
      ;
    };
   };


   method create
   {
     doc "this method creates user and sets ACL to allow changing of acls to active role";

     id_permission __PERMISSION_CREATE;
     sec_type __METHOD_SEC_TYPE_CLASS;

#include "../../include/create_header.t"

     declare language_c
     {
       C 'int id_new;';
       C 'int pos;';
       C 'const char * name ="";';
       C 'const char * password = "";';
       C 'const char * login = "";';
       C 'const char * str_id_parent = "";';
       C 'int old_check_security;';
       C 'int NParams = 0;';

     };

     body language_c
     {
       C
        %%
         // this is nothing just not to start from @
         id_new=0;
         @co_call(par_area,'"generic_acl"',"create",par_area=>par_area,par_class=>par_class,par_id=>par_id,callback=>callback,create_params=>create_params,dont_set_acl=>dont_set_acl);
         id_new = *(int *) cou_getReturnValue(cnx, CO_INTEGER, &err);
         NParams = coa_GetElementCount(cnx, create_params);
         for(pos=0; pos<NParams; pos+=2) 
         {
            if (!strcmp(coa_GetElement(cnx, create_params, pos),"name"))    name            = ap_pstrdup(p, coa_GetElement(cnx, create_params, pos+1));
            if (!strcmp(coa_GetElement(cnx, create_params, pos),"login"))    login          = ap_pstrdup(p, coa_GetElement(cnx, create_params, pos+1));
            if (!strcmp(coa_GetElement(cnx, create_params, pos),"password")) password       = ap_pstrdup(p, coa_GetElement(cnx, create_params, pos+1));
            if (!strcmp(coa_GetElement(cnx, create_params, pos),"id_parent")) str_id_parent = ap_pstrdup(p, coa_GetElement(cnx, create_params, pos+1));
         }
        
        // we switch off checking security to allow changing of name and password
        old_check_security = cnx->check_security;
        cnx->check_security = 0; 
        @co_call(par_area,par_class,"update",par_area=>par_area,par_class=>par_class,par_id=>id_new,par_prop=>'"name"',new_value=>name,version=>0);
        @co_call(par_area,par_class,"update",par_area=>par_area,par_class=>par_class,par_id=>id_new,par_prop=>'"login"',new_value=>login,version=>1);
        @co_call(par_area,'"generic_acl"',"update",par_area=>par_area,par_class=>par_class,par_id=>id_new,par_prop=>'"id_role"',new_value=>str_id_parent,version=>2);

        @co_call(par_area,par_class,"changePasswd",par_area=>par_area,par_class=>par_class,par_id=>id_new,passwd_old=>'""',passwd_new=>password);

	/* user is container for preference and preference uses iacl anyway */
	/* so checking security does not make sense here */
        @co_call(par_area,par_class,"insertChild",par_area=>par_area,par_class=>par_class,par_id=>id_new,child_class=>'"preference"',child_prop=>'"id_user"',foreign_prop=>'"id"');

        cnx->check_security = old_check_security;

        cou_setReturnValue(cnx, &id_new, CO_INTEGER);
        
        %%
        ;
     };
   }; // end of create
 
     
   method changePasswd
   {
     id_permission __PERMISSION_UPDATE_SEC;

     __PARAMS_HEADER
     param passwd_old {type CO_STRING;};
     param passwd_new {type CO_STRING;};

     declare language_c
     {
       C "const char * encoded_real_pw ;" ;
     };

     body language_c
     {
       C
       %%
	/* this is very similar to the check in mod_coffice: */
	__CREATE_QUERY("
SELECT id, passwd FROM co_sec_user WHERE deleted=0 AND id=%d;
	", par_id)

	__SQL_GET_RESULT

	if (!ok) {
	    /*cou_error(cnx, "Unknown user or deleted account");*/
	    cou_sendMessageX( cnx, "Unknown user or deleted account", CO_MSG_FORCE);
	    __CLEAR_RESULT
	    return 0;
	}

	if (ok>1) {
	    cou_error(cnx, "Impossible happened: non-unique id in co_sec_user");
	}

	encoded_real_pw = cor_GetValue(cnx, corec, 0, 1);
	cou_logError(cnx, CO_LOG_DEBUG, "old_passwd='%s'  encoded was: '%s'", passwd_old,encoded_real_pw);
	if( (*encoded_real_pw != '\0') /* there was password */
	    && strcmp(encoded_real_pw,crypt(passwd_old,encoded_real_pw))) {
    	    /*cou_error(cnx, "User password mismatch: changing password not allowed");*/
	    cou_sendMessageX( cnx, "User password mismatch: changing password not allowed", CO_MSG_FORCE);
	    __CLEAR_RESULT
	    return 0;
	}
	cou_logError(cnx, CO_LOG_DEBUG, "Clearing result");
	__CLEAR_RESULT
	cou_logError(cnx, CO_LOG_DEBUG, "...Cleared");
	/* we have user found that user knows the old password  */
	/* so he is allowed to change it */
	__CREATE_QUERY("
UPDATE co_sec_user SET version=version+1, passwd='%s' WHERE deleted=0 AND id=%d;
	",  crypt(passwd_new, co_priv_getSalt()), par_id)

        __SQL_EXEC
	if (ok) {
	    cou_sendMessageX( cnx, "Password changed", CO_MSG_FORCE);
	} else {
	    cou_sendMessageX( cnx, "Changing password failed", CO_MSG_FORCE);
	}
       %%
      ;
     };
   };
   
};  
