//LIBRARY FUNCTIONS

//clears tag
function clear(div)
{
   while(div.hasChildNodes())
   {
     var child = div.firstChild;
     div.removeChild(child);
   };
};

function objToString(o)
{
  var ret = new String();
  for(var f in o)
  {
    if(typeof(o[f]) == "object")
    {
      ret+= "\n"+f.toString() + "->" + objToString(o[f]);
    }
    else
    {
      ret += f.toString()+":"+o[f]+";";
    };  
  };  
  return ret;
};

function nope() {};

// ARRAY EXTENTIONS

function class_Array_append(el)
{
  this[this.length] = el;
}

function class_Array_insert(el, index)
{
  for(var i= this.length-1; i >= index ; i--)
  {
    this[i+1]=this[i];
  }
  this[index]=el;
}

function class_Array_deleteElem(index)
{
  for(var i=index; i < this.length-1; i++)
  {
    this[i]=this[i+1];
  }
  this.length--;
}

function class_Array_contains(value)
{
  for(var i=0; i < this.length; i++)
  {
    if(this[i]==value) return true;
  }
  return false;
}


Array.prototype.append = class_Array_append;
Array.prototype.insert = class_Array_insert;
Array.prototype.deleteElem = class_Array_deleteElem;
Array.prototype.contains = class_Array_contains;

// END OF ARRAY EXTENTIONS

// STRING EXTENTIONS

function class_String_count(subStr)
{
	var off = 0;
	var ret = 0;
	var len = subStr.length;
	if(len==0) return -1;
	while(true)
	{
		off=this.indexOf(subStr, off);
//		alert(off);
		if(off==-1) break;
		off+=len;
		ret++;
	}
	return ret;
}


String.prototype.count = class_String_count;

// END OF STRING EXTENTIONS


// EXTENTIONS FOR HTMLTableElement

/*
function class_HTMLTableElement_deleteColumn(index)
{
  var rnum = this.rows.length;
  for(var i=0; i< rnum; i++)
  {
    this.rows[i].deleteCell(index);
  }
}

HTMLTableElement.prototype.deleteColumn = class_HTMLTableElement_deleteColumn;
*/

function htmlTable_deleteColumn(tab, index)
{
  var rnum = tab.rows.length;
  for(var i=0; i< rnum; i++)
  {
    tab.rows[i].deleteCell(index);
  }
}

function htmlTable_insertColumn(tab, index)
{
  var rnum = tab.rows.length;
  for(var i=0; i< rnum; i++)
  {
    tab.rows[i].insertCell(index);
  }
}

// END OF EXTENTIONS FOR HTMLTableElement


//EXTENTIONS FOR HTMLSelectElement

function htmlSelect_createFromArrays(arrLabels, arrValues, value)
{
	var ret = document.createElement("SELECT");
	var selectedIndex;
	for(var j=0; j<arrValues.length; j++)
	{
		var opt = document.createElement("OPTION");
		var text = document.createTextNode(arrLabels[j]);
		opt.appendChild(text);
		opt.value = arrValues[j];
		if((is_ie5up)&&(arrValues[j]==value))
		{
			opt.selected = true; //IE; according to DOM1 OPTION.selected is readonly
		}
		ret.appendChild(opt);
		if(arrValues[j]==value)
		{
			opt.defaultSelected = true; // possible only after this option was added to SELECT
		}
	} // for
	return ret;
}

function htmlSelect_createFromArraysMultiple(arrLabels, arrValues, values)
{
	var ret = document.createElement("DIV");
	var arrSetValues = eval("new Array("+values+")");
	var strRet = "<SELECT MULTIPLE=1 >";

	for(var j=0; j<arrValues.length; j++)
	{
		strRet += "<OPTION";
		if(arrSetValues.contains(arrValues[j]))
		{
			strRet += " SELECTED ";
		}
		strRet += " VALUE=\""+ arrValues[j]+"\" >" + arrLabels[j] + "</OPTION>";
	}

//	alert(strRet);
	ret.innerHTML = strRet;
	
// IE:	return ret.children[0];
	return ret.firstChild;
}


function htmlSelect_refreshFromArrays(select_tag, arrLabels, arrValues, value)
{
	clear(select_tag);
	for(var j=0; j<arrValues.length; j++)
	{
		var opt = document.createElement("OPTION");
		var text = document.createTextNode(arrLabels[j]);
		opt.appendChild(text);
		opt.value = arrValues[j];
		if(arrValues[j]==value)
		{
			opt.selected = true;
		}
		select_tag.appendChild(opt);
	} // for
	return select_tag;
}

function htmlSelect_refreshFromArraysMultiple(select_tag, arrLabels, arrValues, values)
{
	clear(select_tag);
	var arrSetValues = eval("new Array("+values+")");

	for(var j=0; j<arrValues.length; j++)
	{
		var opt = document.createElement("OPTION");
		var text = document.createTextNode(arrLabels[j]);
		opt.appendChild(text);
		opt.value = arrValues[j];
		if(arrSetValues.contains(arrValues[j]))
		{
			opt.selected = true;
		}
		ret.appendChild(opt);
	} // for
	ret.multiple = true;
	return select_tag;
}
// END OF EXTENTIONS FOR HTMLSelect

//-----------------END OF LIBRARY
