#ifndef COCONTEXTH
#define COCONTEXTH

#include "httpd.h"
#include "libpq-fe.h"
//#include "../coffice/co_string.h"

#if !defined(bool)
    typedef enum { false=0, true=1 } co_type_bool;
    #define bool co_type_bool
#endif

/* include "httpd.h" and "libpq-fe.h" before this file */
/* get/setResult types */
typedef enum { 
    CO_NO_TYPE=-1,
    /* starts from 0 */
    CO_STRING=0,
    CO_INTEGER=1,
    CO_RECORDSET=2,
    CO_STRING_SQL_VALUE=3,
    CO_STRING_SQL_NAME = 4,
    CO_ARRAY_OF_STRINGS = 5,
    CO_POINTER=100
} co_value_type;

typedef enum {
    CO_CLIENT_NO_MODE=-1,
    CO_CLIENT_HTML   =0,
    CO_CLIENT_JS     =1,
    CO_CLIENT_ASP    =2
} co_client_mode;

typedef enum {
    CO_NO_HTML = -1,
    CO_OUTSIDE =  0,
    CO_HTML    =  1,
    CO_HEAD    =  2,
    CO_BODY    =  3,
    CO_SCRIPT  =  4
} co_html_mode;

typedef co_value_type co_result_type;

typedef union co_value {
	int value_int;
	const char* value_string;
	PGresult * value_recordset;
} co_value;

typedef struct co_context {
    request_rec *request;
    PGconn *dbconn;
/* private fields follow: */
    int error;
    /* basic prameters from url */
    const char* par_area;
    const char* par_class;
    const char* method_args;
    int id_session;
    int id_user;
    int id_role;
    int id_permission;

    void *result;
    co_value_type result_type;
    const char* module_name;
    bool putJS;
    sigjmp_buf sigenv;
    struct JSContext *jscnx;
    const char *post_args; /* not null iff method POST was used */
    int debug_level;
    int check_security; /* this flag is VERY important!, when set to 0, security system is switched off! */
    co_client_mode client_mode;
    int send_data; /* indicates whether we expect methods to send data directly to client */
    co_html_mode html_mode;
    struct co_string *js_response;
    struct co_string *messages;

    /* localization */
    const char* language;
    const char* territory;
    const char* charset;

    /* error handling */
    bool critical;    
} co_context;

#endif
