#!/usr/bin/perl
######################### We start with some black magic to print on failure.
BEGIN { $| = 1; }
END {print "test failed \n" unless \$loaded;}
use Pg;
$loaded = 1;
use strict;
######################### End of black magic.
##my $dbmain = 'nobody';
##my $dbname = 'nobody';
my $dbconnstr = 'dbname=nobody';
my $trace  = '/tmp/pgtrace.out';
my ($conn, $result, $i, $last_id);
my $DEBUG  = 0; # set this to 1 for traces
$SIG{PIPE} = sub { print "broken pipe \n" };
$dbconnstr = $ARGV[0]; shift;
######################### create and connect to database
my $Option_ref = Pg::conndefaults();
my ($key, $val);
( $$Option_ref{port} ne "" && $$Option_ref{dbname} ne "" && $$Option_ref{user} ne "" )
and print "Pg::conndefaults ........ ok \n"
or  die   "Pg::conndefaults ........ not ok: ", $conn->errorMessage;
sub sql_exe
{
   my($conn, $sql) = @_;
   my($ret) = $conn->exec($sql); # || die "ERROR in executing $sql \n" ;
   if(PGRES_COMMAND_OK ne $ret->resultStatus) 
   {
      $!=-1; 
      die "SQL: ".$sql." ".$conn->errorMessage;
   }
   return $ret;
}

sub sql_sel
{
   my($conn, $sql) = @_;
   my($ret) = $conn->exec($sql); # || die "ERROR in executing $sql \n" ;
   if(PGRES_TUPLES_OK ne $ret->resultStatus)
   {
       $!=-1; 
       die "SQL: ".$sql." ".$conn->errorMessage;
   }  
   return $ret;
}

my(@parents);

$conn = Pg::connectdb($dbconnstr);
( PGRES_CONNECTION_OK eq $conn->status )
    and print "Pg::connectdb ........... ok \n"
    or  die   "Pg::connectdb ........... not ok: ", $conn->errorMessage;  
      $conn->exec("DELETE FROM co_sec_role");
      $conn->exec("DROP SEQUENCE co_sec_role_sqid");
      $conn->exec("CREATE SEQUENCE co_sec_role_sqid");
      $conn->exec("GRANT ALL ON co_sec_role_sqid TO nobody");



###########################################################################################
#AREA.CLASS sec.role 
$result = sql_exe($conn, "DELETE FROM co_sec_role WHERE name='root'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_role (deleted  , name , id_catalog_type , id_user , id_item) 
SELECT 0 , 'root' , (SELECT id FROM co_sec_catalog_type WHERE class_name = 'role') , (SELECT id FROM co_sec_user WHERE name = 'System') , (SELECT last_value from co_sec_role_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_role_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='role';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'role'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.role 
$result = sql_exe($conn, "DELETE FROM co_sec_role WHERE name='developer'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_role (deleted  , name , id_catalog_type , id_parent , id_user , id_item) 
SELECT 0 , 'developer' , (SELECT id FROM co_sec_catalog_type WHERE class_name = 'role') , (SELECT id FROM co_sec_role WHERE name = 'root') , (SELECT id FROM co_sec_user WHERE name = 'System') , (SELECT last_value from co_sec_role_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_role_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='role';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'role'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.role 
$result = sql_exe($conn, "DELETE FROM co_sec_role WHERE name='user'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_role (deleted  , name , id_catalog_type , id_parent , id_user , id_item) 
SELECT 0 , 'user' , (SELECT id FROM co_sec_catalog_type WHERE class_name = 'role') , (SELECT id FROM co_sec_role WHERE name = 'root') , (SELECT id FROM co_sec_user WHERE name = 'System') , (SELECT last_value from co_sec_role_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_role_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='role';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'role'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.role 
$result = sql_exe($conn, "DELETE FROM co_sec_role WHERE name='__PUBLIC__'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_role (deleted  , id , name , id_catalog_type , id_parent , id_user , id_item) 
SELECT 0 , '0' , '__PUBLIC__' , (SELECT id FROM co_sec_catalog_type WHERE class_name = 'role') , (SELECT id FROM co_sec_role WHERE name = 'root') , (SELECT id FROM co_sec_user WHERE name = 'System') , '0' "); 

						$result = sql_sel($conn, "SELECT nextval('co_sec_role_sqid')"); 
						my($cval)=($result->fetchrow)[0];
						if(0>$cval)
						{
							$result = sql_sel($conn, "SELECT setval('co_sec_role_sqid', 0)"); 
						}
						$result = sql_sel($conn, "SELECT last_value FROM co_sec_role_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='role';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'role'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         