#!/usr/bin/perl
######################### We start with some black magic to print on failure.
BEGIN { $| = 1; }
END {print "test failed \n" unless \$loaded;}
use Pg;
$loaded = 1;
use strict;
######################### End of black magic.
##my $dbmain = 'nobody';
##my $dbname = 'nobody';
my $dbconnstr = 'dbname=nobody';
my $trace  = '/tmp/pgtrace.out';
my ($conn, $result, $i, $last_id);
my $DEBUG  = 0; # set this to 1 for traces
$SIG{PIPE} = sub { print "broken pipe \n" };
$dbconnstr = $ARGV[0]; shift;
######################### create and connect to database
my $Option_ref = Pg::conndefaults();
my ($key, $val);
( $$Option_ref{port} ne "" && $$Option_ref{dbname} ne "" && $$Option_ref{user} ne "" )
and print "Pg::conndefaults ........ ok \n"
or  die   "Pg::conndefaults ........ not ok: ", $conn->errorMessage;
sub sql_exe
{
   my($conn, $sql) = @_;
   my($ret) = $conn->exec($sql); # || die "ERROR in executing $sql \n" ;
   if(PGRES_COMMAND_OK ne $ret->resultStatus) 
   {
      $!=-1; 
      die "SQL: ".$sql." ".$conn->errorMessage;
   }
   return $ret;
}

sub sql_sel
{
   my($conn, $sql) = @_;
   my($ret) = $conn->exec($sql); # || die "ERROR in executing $sql \n" ;
   if(PGRES_TUPLES_OK ne $ret->resultStatus)
   {
       $!=-1; 
       die "SQL: ".$sql." ".$conn->errorMessage;
   }  
   return $ret;
}

my(@parents);

$conn = Pg::connectdb($dbconnstr);
( PGRES_CONNECTION_OK eq $conn->status )
    and print "Pg::connectdb ........... ok \n"
    or  die   "Pg::connectdb ........... not ok: ", $conn->errorMessage;  


###########################################################################################
#AREA.CLASS sec.report 
$result = sql_exe($conn, " INSERT INTO co_sec_report (deleted  , name , display_name , class_name) 
SELECT 0 , 'test' , 'to jest raport testowy' , 'meta_class' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_report_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='report';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'report'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.report 
$result = sql_exe($conn, " INSERT INTO co_sys_report (deleted  , name , display_name , class_name) 
SELECT 0 , 'test' , 'to jest raport testowy' , 'meta_class' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_report_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='report';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'report'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.report 
$result = sql_exe($conn, " INSERT INTO co_usr_report (deleted  , name , display_name , class_name) 
SELECT 0 , 'test' , 'to jest raport testowy' , 'meta_class' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_report_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='report';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'report'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.report_element 
$result = sql_exe($conn, " INSERT INTO co_sec_report_element (deleted  , id_report , class_name , prop_name , filter_operator , filter_value , active) 
SELECT 0 , (SELECT last_value FROM co_sec_report_sqid) , 'meta_class' , 'class_name' , 'LIKE' , 'g%' , '1' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_report_element_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='report_element';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'report_element'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.report_element 
$result = sql_exe($conn, " INSERT INTO co_sys_report_element (deleted  , id_report , class_name , prop_name , filter_operator , filter_value , active) 
SELECT 0 , (SELECT last_value FROM co_sys_report_sqid) , 'meta_class' , 'class_name' , 'LIKE' , 'g%' , '1' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_report_element_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='report_element';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'report_element'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.report_element 
$result = sql_exe($conn, " INSERT INTO co_usr_report_element (deleted  , id_report , class_name , prop_name , filter_operator , filter_value , active) 
SELECT 0 , (SELECT last_value FROM co_usr_report_sqid) , 'meta_class' , 'class_name' , 'LIKE' , 'g%' , '1' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_report_element_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='report_element';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'report_element'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         