#!/usr/bin/perl
######################### We start with some black magic to print on failure.
BEGIN { $| = 1; }
END {print "test failed \n" unless \$loaded;}
use Pg;
$loaded = 1;
use strict;
######################### End of black magic.
##my $dbmain = 'nobody';
##my $dbname = 'nobody';
my $dbconnstr = 'dbname=nobody';
my $trace  = '/tmp/pgtrace.out';
my ($conn, $result, $i, $last_id);
my $DEBUG  = 0; # set this to 1 for traces
$SIG{PIPE} = sub { print "broken pipe \n" };
$dbconnstr = $ARGV[0]; shift;
######################### create and connect to database
my $Option_ref = Pg::conndefaults();
my ($key, $val);
( $$Option_ref{port} ne "" && $$Option_ref{dbname} ne "" && $$Option_ref{user} ne "" )
and print "Pg::conndefaults ........ ok \n"
or  die   "Pg::conndefaults ........ not ok: ", $conn->errorMessage;
sub sql_exe
{
   my($conn, $sql) = @_;
   my($ret) = $conn->exec($sql); # || die "ERROR in executing $sql \n" ;
   if(PGRES_COMMAND_OK ne $ret->resultStatus) 
   {
      $!=-1; 
      die "SQL: ".$sql." ".$conn->errorMessage;
   }
   return $ret;
}

sub sql_sel
{
   my($conn, $sql) = @_;
   my($ret) = $conn->exec($sql); # || die "ERROR in executing $sql \n" ;
   if(PGRES_TUPLES_OK ne $ret->resultStatus)
   {
       $!=-1; 
       die "SQL: ".$sql." ".$conn->errorMessage;
   }  
   return $ret;
}

my(@parents);

$conn = Pg::connectdb($dbconnstr);
( PGRES_CONNECTION_OK eq $conn->status )
    and print "Pg::connectdb ........... ok \n"
    or  die   "Pg::connectdb ........... not ok: ", $conn->errorMessage;  


###########################################################################################
#AREA.CLASS sec.menu 
$result = sql_exe($conn, "DELETE FROM co_sec_menu WHERE name='default#single\@user'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_menu (deleted  , name , id_parent , class_name) 
SELECT 0 , 'default#single\\\@user' , (SELECT id FROM co_sec_menu WHERE name = 'root') , 'user' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.js_code 
$result = sql_exe($conn, " INSERT INTO co_sec_js_code (deleted  , code) 
SELECT 0 , '        ap_write(\\\"window.open(\\\'../../asp/sys/user?changePasswd&par_id=\\\"+ context.active_item +\\\"\\\');\\\");
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action 
$result = sql_exe($conn, "DELETE FROM co_sec_menu_action WHERE name='user_Change password'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'user_Change password' , (SELECT last_value FROM co_sec_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu 
$result = sql_exe($conn, "DELETE FROM co_sec_menu WHERE name='Change_password' AND class_name='user'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_menu (deleted  , name , display_name , class_name , id_parent , id_menu_action , id_permission) 
SELECT 0 , 'Change_password' , 'Zmie haso' , 'user' , (SELECT id FROM co_sec_menu WHERE name = 'default#single\\\@user') , (SELECT last_value FROM co_sec_menu_action_sqid) , '2' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         