#!/usr/bin/perl  
use strict;
use co;
use tools;
use co_modules_functions;

#$user = $ENV{"USER"};

my($root, $item_list, $files, $prop, $file);

my($method_header) = 
'
';

#Getting the parsed tree
$root = &co::parse("sss", $ARGV[0]);

print "begining \n";


$item_list = $root->{"item_list"}; 

#creating type map
my($arr_type) = $item_list->{"type"};

print "We have $#{@$arr_type} types \n";

#we should define this as global
my(%co_type_map);
my($type);
foreach $type (@$arr_type)
{
    my($name_type) = $type->{"V"};
    my($name_c_type) = $type->{"c_type"}->[0]->{"V"}; 
    my($name_sql_type) = $type->{"sql_type"}->[0]->{"V"};
    my($name_js_type) = $type->{"js_type"}->[0]->{"V"}; 
    my($name_pointer) = $type->{"pointer"}->[0]->{"V"}; 
    my($name_is_array) = $type->{"is_array"}->[0]->{"V"}; 
    
    $co_type_map{$name_type} = { "c_type" => $name_c_type, "js_type" => $name_js_type, "pointer" => $name_pointer, "is_array" => $name_is_array, "sql_type" => $name_sql_type};
#    print $co_type_map{$name_type}{"c_type"} . "\n" ;

};    

my($arr_class) = $item_list->{"class"};
my($class);
foreach $class (@$arr_class)
{
     my($name_class) = $class->{"V"};
    
     my($arr_area) = $class->{"area"};
     my($area);
     foreach $area (@$arr_area)
     {
         my($name_area) = $area->{"V"};

###################################################################################################################
# CREATION OF CLASSES AND INDEXES
#
         print "Opening file  co_create_${name_area}_${name_class}.sql \n ";

         open (OUTF , "> co_create_${name_area}_${name_class}.sql ") || die "Could not open co_create_${name_area}_${name_class}.sql";
  
            print OUTF "
      DROP TABLE co_tmp_${name_area}_${name_class}\n
      !NOERROR\n
      ALTER TABLE co_${name_area}_${name_class} RENAME TO co_tmp_${name_area}_${name_class}\n
      !NOERROR\n";

         my($arr_sequence) = $class->{"sequence"};
         my($sequence);
         foreach $sequence (@$arr_sequence)
         {
            my($name_sequence) = $sequence->{"V"};
            print OUTF "
      drop sequence co_${name_area}_${name_class}_${name_sequence}
      !NOERROR
      create sequence co_${name_area}_${name_class}_${name_sequence} start 1
      !GO
      grant all on co_${name_area}_${name_class}_${name_sequence} to nobody
      !GO \n";
         } #@end .. sequence

         print OUTF "
  create table co_${name_area}_${name_class}
  ( \n ";

         my($i)=0;  
         my($arr_prop) = $class->{"prop"};
		 my($name_inherits_table) = $class->{"inherits_table"}->[0]->{"V"};
         my($prop);
         foreach $prop (@$arr_prop)
         {
            my($name_prop) = $prop->{"V"};
            my($name_f_body) =    $prop->{"f_body"}->[0]->{"V"};
            my($name_type) =      $prop->{"type"}->[0]->{"V"};
            my($name_inherited) = $prop->{"inherited"}->[0]->{"V"};
            my($name_default) =      $prop->{"default"}->[0]->{"V"};
            my($sql_type) =  $co_type_map{$name_type}{"sql_type"};

            if(!$name_f_body && !$name_inherited)
            {
               if ($i != 0) { print OUTF " , \n"; };
               $i++;
               print OUTF " $name_prop  $sql_type default \n";
               if($name_default eq "SEQUENCE") 
               {
                 my($name_sq_name) = $prop->{"default"}->[0]->{"sq_name"}->[0]->{"V"};
                 print OUTF "nextval('co_${name_area}_${name_class}_${name_sq_name}'::text) \n";
               }else
               {
                  print OUTF $name_default . "\n" ;
               }
            } # if
          } # @end .. prop

  print OUTF "
  )";

  if($name_inherits_table ne "") 
  {
    print OUTF " INHERITS ( co_${name_area}_${name_inherits_table} )";
  }

  print OUTF "
  !GO
  grant all on co_${name_area}_${name_class} to nobody
  !GO 
  ";

         my($arr_index) = $class->{"index"};
         my($index);
         foreach $index (@$arr_index)
         {
            my($name_index) = $index->{"V"};
            my($name_unique) = $index->{"unique"}->[0]->{"V"};
            print OUTF " 
    DROP INDEX co_${name_area}_${name_class}_${name_index}
    !NOERROR
    
    CREATE  ";
            if($name_unique) { print OUTF " UNIQUE "; };
            print OUTF "   
    INDEX co_${name_area}_${name_class}_${name_index}
    ON co_${name_area}_${name_class}
    ( \n ";
            $i=0;  
            my($arr_column) = $index->{"column"};
            my($column);
            foreach $column (@$arr_column)
            {
               my($name_column) = $column->{"V"};
               if ($i != 0 ) { print OUTF " , ";};
               print OUTF $name_column . " " ; 
               $i++;
            } #@end .. column
            print OUTF "
    )
    !GO
    ";

         } # @end .. index
  
   close OUTF;

###################################################################################################################
# DATA IMPORT FROM RECENT BUILD

    print "Opening file  import_${name_area}_${name_class}.sql.export \n ";

         open (OUTF , "> import_${name_area}_${name_class}.sql.export ") || die "Could not open import_${name_area}_${name_class}.sql.export";
  
         print OUTF "INSERT INTO co_${name_area}_${name_class} SELECT * FROM co_tmp_${name_area}_${name_class} \n!GO\n";
         print OUTF "SELECT setval('co_${name_area}_${name_class}_sqid',(SELECT max(id) FROM co_${name_area}_${name_class}))\n!NOERROR";

         close OUTF;

###################################################################################################################
# TEMPORARY TABLE DROP

    print "Opening file  drop_tmp_${name_area}_${name_class}.sql.export \n ";

         open (OUTF , "> drop_tmp_${name_area}_${name_class}.sql.export ") || die "Could not open drop_tmp_${name_area}_${name_class}.sql.export";
  
         print OUTF "DROP TABLE co_tmp_${name_area}_${name_class} \n!NOERROR\n";

         close OUTF;

##################################################################################################
# INITIALIZING META STRUCTRURES
#
#

  print  "Opening file co_init_${name_area}_${name_class}.sql \n";
  open (OUTF , "> co_init_${name_area}_${name_class}.sql" ) || die  "Could not open co_init_${name_area}_${name_class}.sql";

  print  "Opening file co_initv_${name_area}_${name_class}.sql \n";
  open (OUTF2 , "> co_initv_${name_area}_${name_class}.sql" ) || die  "Could not open co_initv_${name_area}_${name_class}.sql";


  my($name_inherits)             = $class->{"inherits"}->[0]->{"V"};
  my($name_container_class)      = $class->{"container_class"}->[0]->{"V"};
  my($name_container_column_name)= $class->{"container_column_name"}->[0]->{"V"};
  my($name_default_form)         = $class->{"default_form"}->[0]->{"V"};
  my($name_force_sec_type)         = $area->{"force_sec_type"}->[0]->{"V"};
  
  print OUTF "
  select co_${name_area}_meta_class_add('$name_class', '$name_inherits' , '$name_container_class', '$name_container_column_name')
  !SELECT

  UPDATE co_${name_area}_meta_class SET default_form = '$name_default_form', force_sec_type='${name_force_sec_type}' WHERE class_name = '$name_class'
  !GO

DELETE FROM co_${name_area}_meta_prop WHERE class_name='$name_class'
!GO
  ";

    my($arr_language) = $class->{"language"};
    my($language);
    foreach $language (@$arr_language)
    {
    	my($name_language) = $language->{"V"};
    	my($label_text) =   $language->{"label"}->[0]->{"V"};
    	print OUTF "
insert into co_${name_area}_label_class(id_meta_class, language, text)
  values( (SELECT last_value FROM co_${name_area}_meta_class_sqid) ,'$name_language','$label_text')
!GO  
"; 
    }
 
         my($arr_prop) = $class->{"prop"};
         my($prop);
         foreach $prop (@$arr_prop)
         {
            my($name_prop) = $prop->{"V"};
            my($name_f_body) =    $prop->{"f_body"}->[0]->{"V"};
            my($name_type) =      $prop->{"type"}->[0]->{"V"};
            my($name_params) =      $prop->{"params"}->[0]->{"V"};
            $name_params =~ s/([\"|\'|\\])/\\\1/g;
            my($name_representant) =      $prop->{"representant"}->[0]->{"V"};
            my($name_foreign) =      $prop->{"foreign"}->[0]->{"V"};
            my($name_foreign_prop) =      $prop->{"foreign_prop"}->[0]->{"V"};
	    my($name_foreign_dynamic) =   $prop->{"foreign_dynamic"}->[0]->{"V"};
	    my($name_foreign_dynamic_classes) =   $prop->{"foreign_dynamic_classes"}->[0]->{"V"};
	    my($name_foreign_dynamic_prop) =   $prop->{"foreign_dynamic_prop"}->[0]->{"V"};
            my($name_position) =      $prop->{"position"}->[0]->{"V"};
            my($name_default) =    $prop->{"default"}->[0]->{"V"};
			my($name_group_path) = $prop->{"group_path"}->[0]->{"V"};
            my($sql_type) =  $co_type_map{$name_type}{"sql_type"};

            print OUTF "
INSERT INTO co_${name_area}_meta_prop(class_name, prop_name, prop_params, prop_representant, 
     prop_foreign, prop_foreign_prop,  prop_foreign_dynamic, prop_foreign_dynamic_classes, prop_foreign_dynamic_prop, 
     prop_position, prop_type, prop_group_path)
  VALUES('$name_class', '$name_prop','$name_params','$name_representant','$name_foreign','$name_foreign_prop',
         '$name_foreign_dynamic', '$name_foreign_dynamic_classes', '$name_foreign_dynamic_prop', 
	 '$name_position','$name_type', '$name_group_path')
!GO  
"; 
    	    my($arr_language) = $prop->{"language"};
    	    my($language);
    	    foreach $language (@$arr_language)
    	    {
        	my($name_language) = $language->{"V"};
        	my($label_text) =   $language->{"label"}->[0]->{"V"};
        	my($relation_label_text) =   $language->{"relation"}->[0]->{"V"};
		if ($label_text ne "") {
        	    print OUTF "
insert into co_${name_area}_label_prop(id_meta_prop, language, text)
  values( (SELECT last_value FROM co_${name_area}_meta_prop_sqid) ,'$name_language','$label_text')
!GO
";
		}
		if ($relation_label_text ne "") {
        	    print OUTF "
insert into co_${name_area}_label_relation(id_meta_prop, language, text)
  values( (SELECT last_value FROM co_${name_area}_meta_prop_sqid) ,'$name_language','$relation_label_text')
!GO  
"; 
		}
	    }

         } # @end .. prop

        print OUTF "
DELETE FROM co_${name_area}_meta_method WHERE class_name='$name_class'
!GO
";

     my($arr_method) = $class->{"method"};
     my($method);
     foreach $method (@$arr_method)
     {
        my($name_method) = $method->{"V"};
        my($name_id_permission) = $method->{"id_permission"}->[0]->{"V"};
        my($name_profiled) = $method->{"profiled"}->[0]->{"V"};
        my($name_sec_type) = $method->{"sec_type"}->[0]->{"V"};
       
       print OUTF "
insert into co_${name_area}_meta_method(class_name, method_name, id_permission, sec_type, force_sec_type)
            values('$name_class', '$name_method','$name_id_permission', '$name_sec_type', '$name_force_sec_type')
!GO
";
       if($name_profiled)
       {
          print OUTF "
update co_${name_area}_meta_method set profiled=1
where class_name='$name_class' and method_name='$name_method'
!GO
";     
       } 
       
       my($arr_server_event) =  $method->{"server_event"};
       my($server_event);
       foreach $server_event (@$arr_server_event)
       {
          my($name_server_event) = $server_event->{"V"};

          my($arr_execute_jscript) = $server_event->{"execute_jscript"};
          my($execute_jscript);
          foreach $execute_jscript (@$arr_execute_jscript)
          {
             my($name_execute_jscript) = $execute_jscript->{"V"};
	     $name_execute_jscript =~ s/([\"|\'|\\])/\\\1/g;
#  @openfile co_init_${name_area}_${name_class}.sql -append
             print OUTF "
insert into co_${name_area}_js_code(code) values('${name_execute_jscript}')
!GO
update co_${name_area}_meta_method
set id_${name_server_event}_script=(select last_value from co_${name_area}_js_code_sqid)
where class_name='$name_class' and method_name='$name_method'
!GO
";
	  } # @end .. execute_jscript
          my($arr_execute) = $server_event->{"execute"};
          my($execute);
          foreach $execute (@$arr_execute)
          {
             my($name_execute) =    $execute->{"V"};
             my($name_class_name) = $execute->{"class_name"}->[0]->{"V"};
             my($name_method_name) = $execute->{"method_name"}->[0]->{"V"};
 # @openfile co_initv_${name_area}_${name_class}.sql -append
             print OUTF2 " 
update co_${name_area}_meta_method
set id_${name_server_event}_method=
(select id from co_${name_area}_meta_method
 where class_name='${name_class_name}' and method_name='${name_method_name}')
where class_name='${name_class}' and method_name='${name_method}'
!GO
";
         } # @end .. execute
      } # end .. server_event
    } # @end .. method

  close OUTF;

################################################################################################
# INITIALIZING VTABLE
#
#  print "Opening file  co_initv_${name_area}_${name_class}.sql \n ";
#  open (OUTF, "> co_initv_${name_area}_${name_class}.sql" ) || die "Could not open  co_initv_${name_area}_${name_class}.sql";

  print OUTF2 "
select co_${name_area}_meta_vtable_generate('${name_class}')
!SELECT
";

  close OUTF2;

#################################################################################################
# CREATION OF FUNCTIONS
#
  print "Opening file  co_functions_${name_area}_${name_class}.sql \n ";
  open (OUTF, "> co_functions_${name_area}_${name_class}.sql" ) || die "Could not open   co_functions_${name_area}_${name_class}.sql";

     my($arr_function_sql) = $class->{"function_sql"};
     my($function_sql);
     foreach $function_sql (@$arr_function_sql)
     {
        my($name_function_sql) =    $function_sql->{"V"};
        my($name_params)       =    $function_sql->{"params"}->[0]->{"V"};
        my($name_returns)      =    $function_sql->{"returns"}->[0]->{"V"};
        my($name_language)     =    $function_sql->{"language"}->[0]->{"V"};
		if(!$name_language) {$name_language = 'plpgsql';};

        print OUTF " 
          DROP FUNCTION co_${name_area}_${name_class}_${name_function_sql}" . print_C($name_params, $name_area, $name_class) . " 
          !NOERROR 
          CREATE FUNCTION  co_${name_area}_${name_class}_${name_function_sql}" . print_C($name_params, $name_area, $name_class) . "
          RETURNS  $name_returns
          AS ' \n ";
          my($arr_S) = $function_sql->{"S"};
          my($S);
          foreach $S (@$arr_S)
          {
             my($name_S) = $S->{"V"};
             print OUTF print_C($name_S, $name_area, $name_class);  
          } # @end .. S
        print OUTF "
    ' LANGUAGE '$name_language'
    !GO \n ";
    
   } #@end .. function_sql
 
 ##################################################
 # check_acl functions

  my($name_f_check_acl) = $class->{"f_check_acl"}->[0]->{"V"};
  my($name_f_check_acl_class) = $class->{"f_check_acl_class"}->[0]->{"V"};

  print OUTF " 
  DROP FUNCTION co_${name_area}_${name_class}_check_acl(int,int,int) 
  !NOERROR 
  CREATE FUNCTION  co_${name_area}_${name_class}_check_acl(int,int,int)
  RETURNS  int
  AS ' \n";
   if($name_force_sec_type==1)
   {
      print OUTF print_C($name_f_check_acl_class, $name_area, $name_class, $name_container_class, $name_container_column_name); 
   }
   else
   {
      print OUTF print_C($name_f_check_acl, $name_area, $name_class, $name_container_class, $name_container_column_name);
	}	
  print OUTF "' LANGUAGE 'sql' \n!GO \n ";
 
  print OUTF " 
  DROP FUNCTION co_${name_area}_${name_class}_check_acl_class(int,int)
  !NOERROR 
  CREATE FUNCTION  co_${name_area}_${name_class}_check_acl_class(int,int)
  RETURNS  int
  AS ' \n";
      print OUTF print_C($name_f_check_acl_class, $name_area, $name_class) . 
  " \n ' LANGUAGE 'sql'   
    !GO \n ";
    
 
 #######################################
 # creation of lhlo functions
 
     my($arr_prop) = $class->{"prop"};
     my($prop);
     foreach $prop (@$arr_prop)
     {
        my($name_prop) = $prop->{"V"};
        my($name_f_body) =    $prop->{"f_body"}->[0]->{"V"};
        my($name_type) =      $prop->{"type"}->[0]->{"V"};
        my($name_default) =      $prop->{"default"}->[0]->{"V"};
        my($sql_type) =  $co_type_map{$name_type}{"sql_type"};

        if(!$name_f_body)
        {  
        
        print OUTF " 
     DROP FUNCTION lhlo_${name_area}_${name_class}_${name_prop}(${sql_type})
     !NOERROR

     CREATE FUNCTION lhlo_${name_area}_${name_class}_${name_prop}(${sql_type}) RETURNS co_${name_area}_${name_class} AS
     '
        SELECT * FROM co_${name_area}_${name_class} WHERE co_${name_area}_${name_class}.${name_prop} = \$1
     '
     LANGUAGE 'sql'
     !GO
       ";
       } # fi

    } # @end .. prop

     my($arr_prop) = $class->{"prop"};
     my($prop);
     foreach $prop (@$arr_prop)
     {
        my($name_prop) = $prop->{"V"};
        my($name_f_body) =    $prop->{"f_body"}->[0]->{"V"};
        my($name_type) =      $prop->{"type"}->[0]->{"V"};
        my($name_default) =      $prop->{"default"}->[0]->{"V"};
        my($sql_type) =  $co_type_map{$name_type}{"sql_type"};
      
        if($name_f_body)
        {  
          print OUTF " 
     DROP FUNCTION cof_${name_area}_${name_class}_${name_prop}(co_${name_area}_${name_class})
     !NOERROR

     CREATE FUNCTION  cof_${name_area}_${name_class}_${name_prop}(co_${name_area}_${name_class})
            RETURNS $sql_type AS
     '\n";
         print OUTF print_C($name_f_body, $name_area, $name_class);  
         print OUTF "
     '
     LANGUAGE 'sql'
     !GO
      ";
       } # end for if is_function 
    } # @end .. prop

    close OUTF;

#################################################################################################
# CREATING VIEWS
#
  print "Opening file  co_view_${name_area}_${name_class}.sql \n ";
  open (OUTF, "> co_views_${name_area}_${name_class}.sql" ) || die "Could not open   co_views_${name_area}_${name_class}.sql";

     print OUTF "DROP VIEW cov_${name_area}_${name_class} 
     !NOERROR
     ";
     
     print OUTF "CREATE VIEW cov_${name_area}_${name_class} AS 
     SELECT * 
     ";
 
     my($arr_prop) = $class->{"prop"};
     my($prop);
     foreach $prop (@$arr_prop)
     {
        my($name_prop) = $prop->{"V"};
        my($name_f_body) =    $prop->{"f_body"}->[0]->{"V"};
        my($name_type) =      $prop->{"type"}->[0]->{"V"};
        my($name_default) =      $prop->{"default"}->[0]->{"V"};
        my($sql_type) =  $co_type_map{$name_type}{"sql_type"};

        if($name_f_body)
        {  
           print OUTF " , cof_${name_area}_${name_class}_${name_prop}(c) AS ${name_prop} ";
        } # fi

    } # @end .. prop

    print OUTF " FROM  co_${name_area}_${name_class} AS c 
               !GO \n";
 
    print OUTF " GRANT ALL ON  cov_${name_area}_${name_class} TO nobody   
                 !GO \n";
  
    close OUTF;
  
  } # @end .. area
 }# @end .. class
 
