%token WORD_NAME WORD_VAL
%{
package co;
use Carp;

%}

%%
program: /* nothing */
	| classes =
	    {
		#print "yacc: koniec przetwarzania\n";
		$root->{"item_list"} = $1;
		$$ = $1;
	    }	
	;

classes: class = 
	    {
	    	#print "yacc: class : ", $1->{"class_name"}," \n";
		$$=$1;
	    }

	| class  classes =
	    {
		#print "yacc: class classes : ", $1->{"class_name"}," \n";
		$$ = $1;
	    }
	;

class:	
	| WORD_NAME WORD_NAME ';' =
	    {
	    	#print "yacc: WORD WORD: ", $1," ", $2," \n";
		#print "yacc: nastepny element : ", $0->{"ast_node_name"}," \n";

		local($a) = { "V" => $2 };
             		
		if(!($0->{"N"})) 
		{
		    #print "yacc: zakladam nowe temp\n";
		    local($temp) = {"N" => "temp_".$1.$2 };
                    $temp->{$1} = [];
      		    push @{$temp->{$1}} , $a;
		    $$=$temp;
		}
		else
		{
                    if (! exists $0->{$1}) 
                    {
                         $0->{$1} = [];
                    }
            	    push @{ $0->{$1}} , $a;
		    $$=$0;
		}    
		
	    }    


    	| WORD_NAME WORD_NAME '{' classes  '}' ';' =
	    {
		#print "yacc: WORD WORD {}: ", $1," o nazwie: ", $2, " srodek: ",$4->{"ast_node_name"}," \n";
		#print "yacc: nastepny element : ", $0->{"ast_node_name"}," \n";

		local($a) = $4; # comes from leaves
                $a->{"N"} = $1; # now we know the name
                $a->{"V"} = $2; # the only one scalar value
		
		if(!($0->{"N"})) 
		{
		    #print "yacc: zakladam nowe temp\n";
		    local($temp) = {"N" => "temp_".$1.$2 };
                    $temp->{$1} = [];
      		    push @{$temp->{$1}} , $a;
		    $$=$temp;
		}
		else
		{
                    if (! exists $0->{$1}) 
                    {
                         $0->{$1} = [];
                    }
            	    push @{$0->{$1}} , $a;
		    $$=$0;
		}    
	    }
	;
	
		
	
%%

sub yylex
{
  while(1)
  {

    $line =~ s/^\s+//;
    #print "lex: wejscie :|", $line, "|\n";
    if ($line=~ s/^([\w_\**]+)//) {
	$yylval = $1;
	#print "lex: mamy word_name: ", $yylval, "\n";
    	return $WORD_NAME;
    }
    elsif($line=~ s/^(?=")(.*?[^\\])"//) {
        $yylval = substr($1,1);
	#print "lex: mamy cos w przed cudzyslowiu: ", $yylval, "\n";
	$yylval =~ s/\\\"/\"/g;
	#print "lex: mamy cos w cudzyslowiu: ", $yylval, "\n";
	return $WORD_NAME;
    }	
    elsif($line=~ s/^(?=')(.*?[^\\])'//) {
        $yylval = substr($1,1);
	#print "lex: mamy cos w pojedynczym przed cudzyslowiu: ", $yylval, "\n";
	$yylval =~ s/\\\'/\'/g;
	#print "lex: mamy cos w pojedynczym cudzyslowiu: ", $yylval, "\n";
	return $WORD_NAME;
    }	
    elsif($line=~ s/^(\%\%).*//) {
        $yylval = "";
	SUBLOOP: while (defined($line = <P>)) {
          $line_number++;
	  last SUBLOOP if $line=~ s/^(\s+\%\%).*// ;
	  $yylval .= $line
	}  
	#print "lex: mamy cos w procentach: ", $yylval, "\n";
	return $WORD_NAME;
    }	
    elsif ($line=~ s/^([\{\};\.])//) {
	#print "lex: mamy przerywnik", $1, "\n";
	$yylval = ord(substr($1,0,1));
	#print "lex: ", $yylval, "\n";
	return $yylval;
    }
    else {
	get_line();
	last if $koniec;
    }
  }
}

sub yyerror
{
    print "SYNTAX ERROR IN LINE NUMBER: $line_number \n" ;
    print $before_line4 ;
    print $before_line3 ;
    print $before_line2 ;
    print $before_line1 ;
    print $before_line0 ;
#    print $rem_line ;
    die " \n";
}


sub parse{
    my ($package, $filename) = @_;
    open (P, $filename) || die "Could not open $filename : $@";

    $root = {"N" => "Root"};

    get_line();
    &yyparse;	

    return $root;
}

sub get_line {
    $before_line4 = $before_line3;
    $before_line3 = $before_line2;
    $before_line2 = $before_line1;
    $before_line1 = $before_line0;
    $before_line0 = $rem_line;
    while (defined($line = <P>)) {
        $line_number++;
        $rem_line = $line;
        chomp $line;
        $line =~ s#^\s*//.*$##;          # remove comments
        return if $line !~ /^\s*$/;  # return if not white-space
    }
    $koniec = 1;

}


1;

#line 395 "y.tab.pl"
