#!/usr/bin/perl
######################### We start with some black magic to print on failure.
BEGIN { $| = 1; }
END {print "test failed \n" unless \$loaded;}
use Pg;
$loaded = 1;
use strict;
######################### End of black magic.
##my $dbmain = 'nobody';
##my $dbname = 'nobody';
my $dbconnstr = 'dbname=nobody';
my $trace  = '/tmp/pgtrace.out';
my ($conn, $result, $i, $last_id);
my $DEBUG  = 0; # set this to 1 for traces
$SIG{PIPE} = sub { print "broken pipe \n" };
$dbconnstr = $ARGV[0]; shift;
######################### create and connect to database
my $Option_ref = Pg::conndefaults();
my ($key, $val);
( $$Option_ref{port} ne "" && $$Option_ref{dbname} ne "" && $$Option_ref{user} ne "" )
and print "Pg::conndefaults ........ ok \n"
or  die   "Pg::conndefaults ........ not ok: ", $conn->errorMessage;
sub sql_exe
{
   my($conn, $sql) = @_;
   my($ret) = $conn->exec($sql); # || die "ERROR in executing $sql \n" ;
   if(PGRES_COMMAND_OK ne $ret->resultStatus) 
   {
      $!=-1; 
      die "SQL: ".$sql." ".$conn->errorMessage;
   }
   return $ret;
}

sub sql_sel
{
   my($conn, $sql) = @_;
   my($ret) = $conn->exec($sql); # || die "ERROR in executing $sql \n" ;
   if(PGRES_TUPLES_OK ne $ret->resultStatus)
   {
       $!=-1; 
       die "SQL: ".$sql." ".$conn->errorMessage;
   }  
   return $ret;
}

my(@parents);

$conn = Pg::connectdb($dbconnstr);
( PGRES_CONNECTION_OK eq $conn->status )
    and print "Pg::connectdb ........... ok \n"
    or  die   "Pg::connectdb ........... not ok: ", $conn->errorMessage;  


###########################################################################################
#AREA.CLASS sys.menu 
$result = sql_exe($conn, "DELETE FROM co_sys_menu WHERE name='default_catalog'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , id_parent , class_name) 
SELECT 0 , 'default_catalog' , (SELECT id FROM co_sys_menu WHERE name = 'root') , 'catalog' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu 
$result = sql_exe($conn, "DELETE FROM co_sys_menu WHERE name='l_catalog_catalog'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , id_parent , class_name) 
SELECT 0 , 'l_catalog_catalog' , (SELECT id FROM co_sys_menu WHERE name = 'root') , 'catalog' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu 
$result = sql_exe($conn, "DELETE FROM co_sys_menu WHERE name='r_catalog_catalog'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , id_parent , class_name) 
SELECT 0 , 'r_catalog_catalog' , (SELECT id FROM co_sys_menu WHERE name = 'root') , 'catalog' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu 
$result = sql_exe($conn, "DELETE FROM co_sec_menu WHERE name='l_catalog_role'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_menu (deleted  , name , id_parent , class_name) 
SELECT 0 , 'l_catalog_role' , (SELECT id FROM co_sec_menu WHERE name = 'root') , 'catalog' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu 
$result = sql_exe($conn, "DELETE FROM co_sec_menu WHERE name='r_catalog_role'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_menu (deleted  , name , id_parent , class_name) 
SELECT 0 , 'r_catalog_role' , (SELECT id FROM co_sec_menu WHERE name = 'root') , 'catalog' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, "DELETE FROM co_usr_menu WHERE name='r_catalog_app_action'"); 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , id_parent , class_name) 
SELECT 0 , 'r_catalog_app_action' , (SELECT id FROM co_usr_menu WHERE name = 'root') , 'app_action' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, "DELETE FROM co_usr_menu WHERE name='l_catalog_app_action'"); 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , id_parent , class_name) 
SELECT 0 , 'l_catalog_app_action' , (SELECT id FROM co_usr_menu WHERE name = 'root') , 'app_action' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, "DELETE FROM co_usr_menu WHERE name='r_catalog_sdoc'"); 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , id_parent , class_name) 
SELECT 0 , 'r_catalog_sdoc' , (SELECT id FROM co_usr_menu WHERE name = 'root') , 'sdoc' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, "DELETE FROM co_usr_menu WHERE name='l_catalog_sdoc'"); 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , id_parent , class_name) 
SELECT 0 , 'l_catalog_sdoc' , (SELECT id FROM co_usr_menu WHERE name = 'root') , 'sdoc' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, "DELETE FROM co_usr_menu WHERE name='r_catalog_sdoc_tag'"); 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , id_parent , class_name) 
SELECT 0 , 'r_catalog_sdoc_tag' , (SELECT id FROM co_usr_menu WHERE name = 'root') , 'sdoc_tag' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, "DELETE FROM co_usr_menu WHERE name='l_catalog_sdoc_tag'"); 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , id_parent , class_name) 
SELECT 0 , 'l_catalog_sdoc_tag' , (SELECT id FROM co_usr_menu WHERE name = 'root') , 'sdoc_tag' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.js_code 
$result = sql_exe($conn, " INSERT INTO co_sys_js_code (deleted  , code) 
SELECT 0 , '       var par_area = COServer.getAreaName();

       ap_write(\\\"open_url(\\\'/co/asp/\\\" + par_area + \\\"/catalog?deleteItem\\\"+
             \\\"&active_area=\\\"+par_area+
             \\\"&active_class=\\\"+context.active_class+
             \\\"&active_item=\\\" +context.active_item+
             \\\"&active_path=\\\" +context.active_path+
             \\\"&version=\\\"+context.version+
             \\\"&debug_level=0\\\');\\\");
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.js_code 
$result = sql_exe($conn, " INSERT INTO co_sec_js_code (deleted  , code) 
SELECT 0 , '       var par_area = COServer.getAreaName();

       ap_write(\\\"open_url(\\\'/co/asp/\\\" + par_area + \\\"/catalog?deleteItem\\\"+
             \\\"&active_area=\\\"+par_area+
             \\\"&active_class=\\\"+context.active_class+
             \\\"&active_item=\\\" +context.active_item+
             \\\"&active_path=\\\" +context.active_path+
             \\\"&version=\\\"+context.version+
             \\\"&debug_level=0\\\');\\\");
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.js_code 
$result = sql_exe($conn, " INSERT INTO co_usr_js_code (deleted  , code) 
SELECT 0 , '       var par_area = COServer.getAreaName();

       ap_write(\\\"open_url(\\\'/co/asp/\\\" + par_area + \\\"/catalog?deleteItem\\\"+
             \\\"&active_area=\\\"+par_area+
             \\\"&active_class=\\\"+context.active_class+
             \\\"&active_item=\\\" +context.active_item+
             \\\"&active_path=\\\" +context.active_path+
             \\\"&version=\\\"+context.version+
             \\\"&debug_level=0\\\');\\\");
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action 
$result = sql_exe($conn, "DELETE FROM co_sys_menu_action WHERE name='catalog_delete'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_delete' , (SELECT last_value FROM co_sys_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action 
$result = sql_exe($conn, "DELETE FROM co_sec_menu_action WHERE name='catalog_delete'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_delete' , (SELECT last_value FROM co_sec_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action 
$result = sql_exe($conn, "DELETE FROM co_usr_menu_action WHERE name='catalog_delete'"); 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_delete' , (SELECT last_value FROM co_usr_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'version' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'version' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'version' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'delete' , 'catalog' , (SELECT id FROM co_sys_menu WHERE name = 'default_catalog') , (SELECT last_value FROM co_sys_menu_action_sqid) , '3' , '200' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu 
$result = sql_exe($conn, " INSERT INTO co_sec_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'delete' , 'catalog' , (SELECT id FROM co_sec_menu WHERE name = 'default_catalog') , (SELECT last_value FROM co_sec_menu_action_sqid) , '3' , '200' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'delete' , 'catalog' , (SELECT id FROM co_usr_menu WHERE name = 'default_catalog') , (SELECT last_value FROM co_usr_menu_action_sqid) , '3' , '200' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'delete' , 'catalog' , (SELECT id FROM co_sys_menu WHERE name = 'r_catalog_catalog') , (SELECT last_value FROM co_sys_menu_action_sqid) , '3' , '200' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu 
$result = sql_exe($conn, " INSERT INTO co_sec_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'delete' , 'role' , (SELECT id FROM co_sec_menu WHERE name = 'r_catalog_role') , (SELECT last_value FROM co_sec_menu_action_sqid) , '3' , '200' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'delete' , 'app_action' , (SELECT id FROM co_usr_menu WHERE name = 'r_catalog_app_action') , (SELECT last_value FROM co_usr_menu_action_sqid) , '3' , '200' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'delete' , 'sdoc' , (SELECT id FROM co_usr_menu WHERE name = 'r_catalog_sdoc') , (SELECT last_value FROM co_usr_menu_action_sqid) , '3' , '200' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'delete' , 'sdoc_tag' , (SELECT id FROM co_usr_menu WHERE name = 'r_catalog_sdoc_tag') , (SELECT last_value FROM co_usr_menu_action_sqid) , '3' , '200' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.js_code 
$result = sql_exe($conn, " INSERT INTO co_sys_js_code (deleted  , code) 
SELECT 0 , '        var area = COServer.getAreaName();
        ap_write(
          \\\"open_url(\\\'/co/asp/\\\"+area+\\\"/catalog?createItem\\\" +
                 \\\"&active_area=\\\" + area +
                 \\\"&active_class=\\\"+ context.active_class+
                 \\\"&active_item=\\\"+ context.active_item +
                 \\\"&active_path=\\\" +context.active_path +
                 \\\"&debug_level=0\\\');\\\");
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.js_code 
$result = sql_exe($conn, " INSERT INTO co_sec_js_code (deleted  , code) 
SELECT 0 , '        var area = COServer.getAreaName();
        ap_write(
          \\\"open_url(\\\'/co/asp/\\\"+area+\\\"/catalog?createItem\\\" +
                 \\\"&active_area=\\\" + area +
                 \\\"&active_class=\\\"+ context.active_class+
                 \\\"&active_item=\\\"+ context.active_item +
                 \\\"&active_path=\\\" +context.active_path +
                 \\\"&debug_level=0\\\');\\\");
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.js_code 
$result = sql_exe($conn, " INSERT INTO co_usr_js_code (deleted  , code) 
SELECT 0 , '        var area = COServer.getAreaName();
        ap_write(
          \\\"open_url(\\\'/co/asp/\\\"+area+\\\"/catalog?createItem\\\" +
                 \\\"&active_area=\\\" + area +
                 \\\"&active_class=\\\"+ context.active_class+
                 \\\"&active_item=\\\"+ context.active_item +
                 \\\"&active_path=\\\" +context.active_path +
                 \\\"&debug_level=0\\\');\\\");
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action 
$result = sql_exe($conn, "DELETE FROM co_sys_menu_action WHERE name='catalog_new'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_new' , (SELECT last_value FROM co_sys_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action 
$result = sql_exe($conn, "DELETE FROM co_sec_menu_action WHERE name='catalog_new'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_new' , (SELECT last_value FROM co_sec_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action 
$result = sql_exe($conn, "DELETE FROM co_usr_menu_action WHERE name='catalog_new'"); 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_new' , (SELECT last_value FROM co_usr_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'new' , 'catalog' , (SELECT id FROM co_sys_menu WHERE name = 'default_catalog') , (SELECT last_value FROM co_sys_menu_action_sqid) , '8' , '100' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'new' , 'catalog' , (SELECT id FROM co_sys_menu WHERE name = 'l_catalog_catalog') , (SELECT last_value FROM co_sys_menu_action_sqid) , '8' , '100' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu 
$result = sql_exe($conn, " INSERT INTO co_sec_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'new' , 'role' , (SELECT id FROM co_sec_menu WHERE name = 'l_catalog_role') , (SELECT last_value FROM co_sec_menu_action_sqid) , '8' , '100' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'new' , 'app_action' , (SELECT id FROM co_usr_menu WHERE name = 'l_catalog_app_action') , (SELECT last_value FROM co_usr_menu_action_sqid) , '8' , '100' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'new' , 'sdoc' , (SELECT id FROM co_usr_menu WHERE name = 'l_catalog_sdoc') , (SELECT last_value FROM co_usr_menu_action_sqid) , '8' , '100' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'new' , 'sdoc_tag' , (SELECT id FROM co_usr_menu WHERE name = 'l_catalog_sdoc_tag') , (SELECT last_value FROM co_usr_menu_action_sqid) , '8' , '100' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.js_code 
$result = sql_exe($conn, " INSERT INTO co_sys_js_code (deleted  , code) 
SELECT 0 , '        var par_area = COServer.getAreaName();
        ap_write(\\\"open_url(\\\'/co/asp/\\\" + par_area + \\\"/catalog?trash\\\" +
                 \\\"&active_area=\\\"+ par_area+
                 \\\"&active_class=\\\"+ context.active_class+
                 \\\"&active_item=\\\"+context.active_item+
                 \\\"&active_path=\\\" +context.active_path+
                 \\\"&debug_level=0\\\');\\\");
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.js_code 
$result = sql_exe($conn, " INSERT INTO co_sec_js_code (deleted  , code) 
SELECT 0 , '        var par_area = COServer.getAreaName();
        ap_write(\\\"open_url(\\\'/co/asp/\\\" + par_area + \\\"/catalog?trash\\\" +
                 \\\"&active_area=\\\"+ par_area+
                 \\\"&active_class=\\\"+ context.active_class+
                 \\\"&active_item=\\\"+context.active_item+
                 \\\"&active_path=\\\" +context.active_path+
                 \\\"&debug_level=0\\\');\\\");
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.js_code 
$result = sql_exe($conn, " INSERT INTO co_usr_js_code (deleted  , code) 
SELECT 0 , '        var par_area = COServer.getAreaName();
        ap_write(\\\"open_url(\\\'/co/asp/\\\" + par_area + \\\"/catalog?trash\\\" +
                 \\\"&active_area=\\\"+ par_area+
                 \\\"&active_class=\\\"+ context.active_class+
                 \\\"&active_item=\\\"+context.active_item+
                 \\\"&active_path=\\\" +context.active_path+
                 \\\"&debug_level=0\\\');\\\");
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action 
$result = sql_exe($conn, "DELETE FROM co_sys_menu_action WHERE name='catalog_trash'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_trash' , (SELECT last_value FROM co_sys_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action 
$result = sql_exe($conn, "DELETE FROM co_sec_menu_action WHERE name='catalog_trash'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_trash' , (SELECT last_value FROM co_sec_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action 
$result = sql_exe($conn, "DELETE FROM co_usr_menu_action WHERE name='catalog_trash'"); 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_trash' , (SELECT last_value FROM co_usr_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'trash' , 'catalog' , (SELECT id FROM co_sys_menu WHERE name = 'default_catalog') , (SELECT last_value FROM co_sys_menu_action_sqid) , '4' , '300' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'trash' , 'catalog' , (SELECT id FROM co_sys_menu WHERE name = 'l_catalog_catalog') , (SELECT last_value FROM co_sys_menu_action_sqid) , '4' , '300' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu 
$result = sql_exe($conn, " INSERT INTO co_sec_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'trash' , 'role' , (SELECT id FROM co_sec_menu WHERE name = 'l_catalog_role') , (SELECT last_value FROM co_sec_menu_action_sqid) , '4' , '300' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'trash' , 'app_action' , (SELECT id FROM co_usr_menu WHERE name = 'l_catalog_app_action') , (SELECT last_value FROM co_usr_menu_action_sqid) , '4' , '300' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'trash' , 'sdoc' , (SELECT id FROM co_usr_menu WHERE name = 'l_catalog_sdoc') , (SELECT last_value FROM co_usr_menu_action_sqid) , '4' , '300' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'trash' , 'sdoc_tag' , (SELECT id FROM co_usr_menu WHERE name = 'l_catalog_sdoc_tag') , (SELECT last_value FROM co_usr_menu_action_sqid) , '4' , '300' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.js_code 
$result = sql_exe($conn, " INSERT INTO co_sys_js_code (deleted  , code) 
SELECT 0 , '        var par_area = COServer.getAreaName();

        // we read items data
        var meta = new class_meta_class(par_area);
        var cat = eval(\\\"new class_\\\" + context.active_class + \\\"(\\\'\\\" + par_area + \\\"\\\');\\\");
        var rs = cat.getItemData(context.active_item);
        var type_class_name = rs.getValueByName(0, \\\"type_class_name\\\");

        if (type_class_name!=\\\"attachment\\\")
        {
         // we take default form for items class
         var default_form = meta.getDefaultFormByName( -1 , type_class_name);

         // we ask to open window with default form
         ap_write(\\\"open_url(\\\'/co/html/\\\" + par_area+ \\\"/\\\" + type_class_name+\\\"?\\\" + default_form +
                 \\\"&par_area=\\\"+ par_area +
                 \\\"&par_class=\\\"+ type_class_name+
                 \\\"&par_id=\\\"+rs.getValueByName(0,\\\"id_item\\\")+
                 \\\"&active_path=\\\" +context.active_path+
                 \\\"&debug_level=0\\\');\\\");
        }
        else
        {
         //ap_write(\\\"open_url(\\\'/co/attachment/data/\\\"+
         //           rs.getValueByName(0,\\\"id_item\\\")+\\\"/\\\"+
         //	   rs.getValueByName(0,\\\"name\\\")+\\\"\\\');\\\");
         ap_write(\\\"open_url(\\\'/co/html/sys/attachment?getFile&par_id=\\\"+
                     rs.getValueByName(0,\\\"id_item\\\")+\\\"\\\');\\\");
        }
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.js_code 
$result = sql_exe($conn, " INSERT INTO co_sec_js_code (deleted  , code) 
SELECT 0 , '        var par_area = COServer.getAreaName();

        // we read items data
        var meta = new class_meta_class(par_area);
        var cat = eval(\\\"new class_\\\" + context.active_class + \\\"(\\\'\\\" + par_area + \\\"\\\');\\\");
        var rs = cat.getItemData(context.active_item);
        var type_class_name = rs.getValueByName(0, \\\"type_class_name\\\");

        if (type_class_name!=\\\"attachment\\\")
        {
         // we take default form for items class
         var default_form = meta.getDefaultFormByName( -1 , type_class_name);

         // we ask to open window with default form
         ap_write(\\\"open_url(\\\'/co/html/\\\" + par_area+ \\\"/\\\" + type_class_name+\\\"?\\\" + default_form +
                 \\\"&par_area=\\\"+ par_area +
                 \\\"&par_class=\\\"+ type_class_name+
                 \\\"&par_id=\\\"+rs.getValueByName(0,\\\"id_item\\\")+
                 \\\"&active_path=\\\" +context.active_path+
                 \\\"&debug_level=0\\\');\\\");
        }
        else
        {
         //ap_write(\\\"open_url(\\\'/co/attachment/data/\\\"+
         //           rs.getValueByName(0,\\\"id_item\\\")+\\\"/\\\"+
         //	   rs.getValueByName(0,\\\"name\\\")+\\\"\\\');\\\");
         ap_write(\\\"open_url(\\\'/co/html/sys/attachment?getFile&par_id=\\\"+
                     rs.getValueByName(0,\\\"id_item\\\")+\\\"\\\');\\\");
        }
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.js_code 
$result = sql_exe($conn, " INSERT INTO co_usr_js_code (deleted  , code) 
SELECT 0 , '        var par_area = COServer.getAreaName();

        // we read items data
        var meta = new class_meta_class(par_area);
        var cat = eval(\\\"new class_\\\" + context.active_class + \\\"(\\\'\\\" + par_area + \\\"\\\');\\\");
        var rs = cat.getItemData(context.active_item);
        var type_class_name = rs.getValueByName(0, \\\"type_class_name\\\");

        if (type_class_name!=\\\"attachment\\\")
        {
         // we take default form for items class
         var default_form = meta.getDefaultFormByName( -1 , type_class_name);

         // we ask to open window with default form
         ap_write(\\\"open_url(\\\'/co/html/\\\" + par_area+ \\\"/\\\" + type_class_name+\\\"?\\\" + default_form +
                 \\\"&par_area=\\\"+ par_area +
                 \\\"&par_class=\\\"+ type_class_name+
                 \\\"&par_id=\\\"+rs.getValueByName(0,\\\"id_item\\\")+
                 \\\"&active_path=\\\" +context.active_path+
                 \\\"&debug_level=0\\\');\\\");
        }
        else
        {
         //ap_write(\\\"open_url(\\\'/co/attachment/data/\\\"+
         //           rs.getValueByName(0,\\\"id_item\\\")+\\\"/\\\"+
         //	   rs.getValueByName(0,\\\"name\\\")+\\\"\\\');\\\");
         ap_write(\\\"open_url(\\\'/co/html/sys/attachment?getFile&par_id=\\\"+
                     rs.getValueByName(0,\\\"id_item\\\")+\\\"\\\');\\\");
        }
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action 
$result = sql_exe($conn, "DELETE FROM co_sys_menu_action WHERE name='catalog_go'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_go' , (SELECT last_value FROM co_sys_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action 
$result = sql_exe($conn, "DELETE FROM co_sec_menu_action WHERE name='catalog_go'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_go' , (SELECT last_value FROM co_sec_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action 
$result = sql_exe($conn, "DELETE FROM co_usr_menu_action WHERE name='catalog_go'"); 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_go' , (SELECT last_value FROM co_usr_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'go' , 'catalog' , (SELECT id FROM co_sys_menu WHERE name = 'default_catalog') , (SELECT last_value FROM co_sys_menu_action_sqid) , '1' , '100' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'go' , 'catalog' , (SELECT id FROM co_sys_menu WHERE name = 'r_catalog_catalog') , (SELECT last_value FROM co_sys_menu_action_sqid) , '1' , '100' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu 
$result = sql_exe($conn, " INSERT INTO co_sec_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'go' , 'role' , (SELECT id FROM co_sec_menu WHERE name = 'r_catalog_role') , (SELECT last_value FROM co_sec_menu_action_sqid) , '1' , '100' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'go' , 'app_action' , (SELECT id FROM co_usr_menu WHERE name = 'r_catalog_app_action') , (SELECT last_value FROM co_usr_menu_action_sqid) , '1' , '100' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'go' , 'sdoc' , (SELECT id FROM co_usr_menu WHERE name = 'r_catalog_sdoc') , (SELECT last_value FROM co_usr_menu_action_sqid) , '1' , '100' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'go' , 'sdoc_tag' , (SELECT id FROM co_usr_menu WHERE name = 'r_catalog_sdoc_tag') , (SELECT last_value FROM co_usr_menu_action_sqid) , '1' , '100' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.js_code 
$result = sql_exe($conn, " INSERT INTO co_sys_js_code (deleted  , code) 
SELECT 0 , '        var par_area = \\\'sys\\\';

        // we read items data
        var meta = new class_meta_class(par_area);
        var cat = new class_catalog(par_area);
        var rs = cat.getItemData(context.active_item);
        var type_class_name = \\\"attachment\\\";

        // we take default form for items class
        var default_form = meta.getDefaultFormByName( -1, type_class_name);

        // we ask to open window with default form
        ap_write(\\\"open_url(\\\'/co/html/sys/\\\" + type_class_name+\\\"?\\\" + default_form +
                 \\\"&par_area=\\\"+ par_area +
                 \\\"&par_class=catalog\\\" +
                 \\\"&par_id=\\\" + context.active_item +
                 \\\"&active_path=\\\" + context.active_path +
                 \\\"&debug_level=0\\\');\\\");
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action 
$result = sql_exe($conn, "DELETE FROM co_sys_menu_action WHERE name='catalog_attach'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_attach' , (SELECT last_value FROM co_sys_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'attach' , 'catalog' , (SELECT id FROM co_sys_menu WHERE name = 'default_catalog') , (SELECT last_value FROM co_sys_menu_action_sqid) , '8' , '300' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'attach' , 'catalog' , (SELECT id FROM co_sys_menu WHERE name = 'l_catalog_catalog') , (SELECT last_value FROM co_sys_menu_action_sqid) , '8' , '300' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.js_code 
$result = sql_exe($conn, " INSERT INTO co_sys_js_code (deleted  , code) 
SELECT 0 , '       var par_area = COServer.getAreaName();

       ap_write(\\\"open_url(\\\'/co/asp/\\\" + par_area + \\\"/catalog?setACL\\\"+
             \\\"&active_area=\\\"+par_area+
             \\\"&active_class=\\\"+context.active_class+
             \\\"&active_item=\\\" +context.active_item+
             \\\"&active_path=\\\" +context.active_path+
             \\\"&version=\\\"+context.version+
             \\\"&debug_level=0\\\');\\\");
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.js_code 
$result = sql_exe($conn, " INSERT INTO co_sec_js_code (deleted  , code) 
SELECT 0 , '       var par_area = COServer.getAreaName();

       ap_write(\\\"open_url(\\\'/co/asp/\\\" + par_area + \\\"/catalog?setACL\\\"+
             \\\"&active_area=\\\"+par_area+
             \\\"&active_class=\\\"+context.active_class+
             \\\"&active_item=\\\" +context.active_item+
             \\\"&active_path=\\\" +context.active_path+
             \\\"&version=\\\"+context.version+
             \\\"&debug_level=0\\\');\\\");
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.js_code 
$result = sql_exe($conn, " INSERT INTO co_usr_js_code (deleted  , code) 
SELECT 0 , '       var par_area = COServer.getAreaName();

       ap_write(\\\"open_url(\\\'/co/asp/\\\" + par_area + \\\"/catalog?setACL\\\"+
             \\\"&active_area=\\\"+par_area+
             \\\"&active_class=\\\"+context.active_class+
             \\\"&active_item=\\\" +context.active_item+
             \\\"&active_path=\\\" +context.active_path+
             \\\"&version=\\\"+context.version+
             \\\"&debug_level=0\\\');\\\");
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action 
$result = sql_exe($conn, "DELETE FROM co_sys_menu_action WHERE name='catalog_permissions'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_permissions' , (SELECT last_value FROM co_sys_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action 
$result = sql_exe($conn, "DELETE FROM co_sec_menu_action WHERE name='catalog_permissions'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_permissions' , (SELECT last_value FROM co_sec_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action 
$result = sql_exe($conn, "DELETE FROM co_usr_menu_action WHERE name='catalog_permissions'"); 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_permissions' , (SELECT last_value FROM co_usr_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'version' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'version' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'version' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'permissions' , 'catalog' , (SELECT id FROM co_sys_menu WHERE name = 'default_catalog') , (SELECT last_value FROM co_sys_menu_action_sqid) , '6' , '300' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'permissions' , 'catalog' , (SELECT id FROM co_sys_menu WHERE name = 'r_catalog_catalog') , (SELECT last_value FROM co_sys_menu_action_sqid) , '6' , '300' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu 
$result = sql_exe($conn, " INSERT INTO co_sec_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'permissions' , 'role' , (SELECT id FROM co_sec_menu WHERE name = 'r_catalog_role') , (SELECT last_value FROM co_sec_menu_action_sqid) , '6' , '300' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'permissions' , 'app_action' , (SELECT id FROM co_usr_menu WHERE name = 'r_catalog_app_action') , (SELECT last_value FROM co_usr_menu_action_sqid) , '6' , '300' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'permissions' , 'sdoc' , (SELECT id FROM co_usr_menu WHERE name = 'r_catalog_sdoc') , (SELECT last_value FROM co_usr_menu_action_sqid) , '6' , '300' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu 
$result = sql_exe($conn, " INSERT INTO co_usr_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'permissions' , 'sdoc_tag' , (SELECT id FROM co_usr_menu WHERE name = 'r_catalog_sdoc_tag') , (SELECT last_value FROM co_usr_menu_action_sqid) , '6' , '300' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.js_code 
$result = sql_exe($conn, " INSERT INTO co_sys_js_code (deleted  , code) 
SELECT 0 , '        var par_area = COServer.getAreaName();

        ap_write(\\\"open_url(\\\'/co/html/\\\" + par_area+ \\\"/\\\" + context.active_class +\\\"?showForm\\\" +
                 \\\"&par_area=\\\" + par_area +
                 \\\"&par_class=\\\"+ context.active_class +
                 \\\"&par_id=\\\" + context.active_item +
                 \\\"&active_path=\\\" +context.active_path+
                 \\\"&deep_level=1\\\" +
                 \\\"&debug_level=0\\\');\\\");
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.js_code 
$result = sql_exe($conn, " INSERT INTO co_sec_js_code (deleted  , code) 
SELECT 0 , '        var par_area = COServer.getAreaName();

        ap_write(\\\"open_url(\\\'/co/html/\\\" + par_area+ \\\"/\\\" + context.active_class +\\\"?showForm\\\" +
                 \\\"&par_area=\\\" + par_area +
                 \\\"&par_class=\\\"+ context.active_class +
                 \\\"&par_id=\\\" + context.active_item +
                 \\\"&active_path=\\\" +context.active_path+
                 \\\"&deep_level=1\\\" +
                 \\\"&debug_level=0\\\');\\\");
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.js_code 
$result = sql_exe($conn, " INSERT INTO co_usr_js_code (deleted  , code) 
SELECT 0 , '        var par_area = COServer.getAreaName();

        ap_write(\\\"open_url(\\\'/co/html/\\\" + par_area+ \\\"/\\\" + context.active_class +\\\"?showForm\\\" +
                 \\\"&par_area=\\\" + par_area +
                 \\\"&par_class=\\\"+ context.active_class +
                 \\\"&par_id=\\\" + context.active_item +
                 \\\"&active_path=\\\" +context.active_path+
                 \\\"&deep_level=1\\\" +
                 \\\"&debug_level=0\\\');\\\");
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action 
$result = sql_exe($conn, "DELETE FROM co_sys_menu_action WHERE name='catalog_edit'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_edit' , (SELECT last_value FROM co_sys_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action 
$result = sql_exe($conn, "DELETE FROM co_sec_menu_action WHERE name='catalog_edit'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_edit' , (SELECT last_value FROM co_sec_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action 
$result = sql_exe($conn, "DELETE FROM co_usr_menu_action WHERE name='catalog_edit'"); 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_edit' , (SELECT last_value FROM co_usr_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'edit' , 'catalog' , (SELECT id FROM co_sys_menu WHERE name = 'default_catalog') , (SELECT last_value FROM co_sys_menu_action_sqid) , '1' , '100' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'edit' , 'catalog' , (SELECT id FROM co_sys_menu WHERE name = 'r_catalog_catalog') , (SELECT last_value FROM co_sys_menu_action_sqid) , '1' , '100' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.js_code 
$result = sql_exe($conn, " INSERT INTO co_sys_js_code (deleted  , code) 
SELECT 0 , '        var par_area = COServer.getAreaName();
                var cat = eval( \\\"new class_\\\"+context.active_class+\\\"(\\\'\\\"+par_area+\\\"\\\')\\\");
                cat.cut(context.active_item);
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.js_code 
$result = sql_exe($conn, " INSERT INTO co_sec_js_code (deleted  , code) 
SELECT 0 , '        var par_area = COServer.getAreaName();
                var cat = eval( \\\"new class_\\\"+context.active_class+\\\"(\\\'\\\"+par_area+\\\"\\\')\\\");
                cat.cut(context.active_item);
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.js_code 
$result = sql_exe($conn, " INSERT INTO co_usr_js_code (deleted  , code) 
SELECT 0 , '        var par_area = COServer.getAreaName();
                var cat = eval( \\\"new class_\\\"+context.active_class+\\\"(\\\'\\\"+par_area+\\\"\\\')\\\");
                cat.cut(context.active_item);
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action 
$result = sql_exe($conn, "DELETE FROM co_sys_menu_action WHERE name='catalog_cut'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_cut' , (SELECT last_value FROM co_sys_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action 
$result = sql_exe($conn, "DELETE FROM co_sec_menu_action WHERE name='catalog_cut'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_cut' , (SELECT last_value FROM co_sec_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action 
$result = sql_exe($conn, "DELETE FROM co_usr_menu_action WHERE name='catalog_cut'"); 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_cut' , (SELECT last_value FROM co_usr_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'cut' , 'catalog' , (SELECT id FROM co_sys_menu WHERE name = 'default_catalog') , (SELECT last_value FROM co_sys_menu_action_sqid) , '1' , '100' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'cut' , 'catalog' , (SELECT id FROM co_sys_menu WHERE name = 'r_catalog_catalog') , (SELECT last_value FROM co_sys_menu_action_sqid) , '3' , '100' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.js_code 
$result = sql_exe($conn, " INSERT INTO co_sys_js_code (deleted  , code) 
SELECT 0 , '        var par_area = COServer.getAreaName();
                var cat = eval( \\\"new class_\\\"+context.active_class+\\\"(\\\'\\\"+par_area+\\\"\\\')\\\");
                cat.paste(context.active_item);
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.js_code 
$result = sql_exe($conn, " INSERT INTO co_sec_js_code (deleted  , code) 
SELECT 0 , '        var par_area = COServer.getAreaName();
                var cat = eval( \\\"new class_\\\"+context.active_class+\\\"(\\\'\\\"+par_area+\\\"\\\')\\\");
                cat.paste(context.active_item);
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.js_code 
$result = sql_exe($conn, " INSERT INTO co_usr_js_code (deleted  , code) 
SELECT 0 , '        var par_area = COServer.getAreaName();
                var cat = eval( \\\"new class_\\\"+context.active_class+\\\"(\\\'\\\"+par_area+\\\"\\\')\\\");
                cat.paste(context.active_item);
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action 
$result = sql_exe($conn, "DELETE FROM co_sys_menu_action WHERE name='catalog_paste'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_cut' , (SELECT last_value FROM co_sys_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action 
$result = sql_exe($conn, "DELETE FROM co_sec_menu_action WHERE name='catalog_paste'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_cut' , (SELECT last_value FROM co_sec_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action 
$result = sql_exe($conn, "DELETE FROM co_usr_menu_action WHERE name='catalog_paste'"); 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action (deleted  , name , id_js_code) 
SELECT 0 , 'catalog_cut' , (SELECT last_value FROM co_usr_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_class' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_item' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sys_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_sys_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_sec_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_sec_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sec' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.menu_action_param 
$result = sql_exe($conn, " INSERT INTO co_usr_menu_action_param (deleted  , param_name , id_menu_action) 
SELECT 0 , 'active_path' , (SELECT last_value FROM co_usr_menu_action_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_menu_action_param_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='usr' AND class_name='menu_action_param';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'menu_action_param'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'paste' , 'catalog' , (SELECT id FROM co_sys_menu WHERE name = 'default_catalog') , (SELECT last_value FROM co_sys_menu_action_sqid) , '8' , '100' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.menu 
$result = sql_exe($conn, " INSERT INTO co_sys_menu (deleted  , name , class_name , id_parent , id_menu_action , id_permission , menu_position) 
SELECT 0 , 'paste' , 'catalog' , (SELECT id FROM co_sys_menu WHERE name = 'l_catalog_catalog') , (SELECT last_value FROM co_sys_menu_action_sqid) , '8' , '100' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_menu_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='menu';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'menu'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         